*CMZ :          09/02/2002  17.39.35  by   H. Jung
*-- Author :  H. Jung 25-05-96
      subroutine hz00181(IFLAG)
***********************************************
* F2 data
*
***********************************************
      IMPLICIT NONE
*
      Real pi,dpi,rd,ee,eb,dphi,Qpi,qqradp,sigma_tot,xntot
      Logical lp
      data lp/.false./
*
      Character string*20
*
      real alph_em
      Parameter (alph_em=7.29927e-3)
      Real gev2nb,lum,fact

      Integer iqbin,i1,i3,idhisto,idpaw
      Parameter (gev2nb=0.389e6)
      Integer maxhi
      Parameter (maxhi=2000)
      Real nev(maxhi)
      Integer nentry
      Real n2,nall,nall2
      Real xw
      Data nall/0/
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real x,y,w2,q2

      double precision dx,dq
      real f2pdf
      DOUBLE PRECISION XXX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU,
     +VAL(20)
      CHARACTER*20 PARM(20)
      Integer npdf
      DATA NPDF/0/,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU/9*0.D0/
      LOGICAL PDFFIRST
      COMMON /W50516/PDFFIRST

*
*
* F2 data
*
      Integer nf1
      Parameter (nf1=3)
      Integer nf2
      Parameter (nf2=9)
      Integer nf3
      Parameter (nf3=10)
      Integer nf4
      Parameter (nf4=11)
      Integer nf5
      Parameter (nf5=8)
      Integer nf6
      Parameter (nf6=7)
       Integer nf7
      Parameter (nf7=4)
      Real xx1(nf1),yy1(nf1)
      Real xx2(nf2),yy2(nf2)
      Real xx3(nf3),yy3(nf3)
      Real xx4(nf3),yy4(nf3)
      Real xx5(nf3),yy5(nf3)
      Real xx6(nf2),yy6(nf2)
      Real xx7(nf3),yy7(nf3)
      Real xx8(nf3),yy8(nf3)
      Real xx9(nf4),yy9(nf4)
      Real xx10(nf3),yy10(nf3)
      Real xx11(nf4),yy11(nf4)
      Real xx12(nf3),yy12(nf3)
      Real xx13(nf5),yy13(nf5)
      Real xx14(nf5),yy14(nf5)
      Real xx15(nf6),yy15(nf6)
      Real xx16(nf6),yy16(nf6)
      Real xx17(nf7),yy17(nf7)
      Integer nxbin
	Parameter (nxbin=26)
	
      Integer nxbin1
	Parameter (nxbin1=14)
      Integer nxbin2
	Parameter (nxbin2=12)
      Integer nxbin3
	Parameter (nxbin3=12)
      Integer nxbin4
	Parameter (nxbin4=12)
      Integer nxbin5
	Parameter (nxbin5=12)
      Integer nxbin6
	Parameter (nxbin6=12)
      Integer nxbin7
	Parameter (nxbin7=12)
      Integer nxbin8
	Parameter (nxbin8=12)
      Integer nxbin9
	Parameter (nxbin9=14)
      Integer nxbin10
	Parameter (nxbin10=13)
      Integer nxbin11
	Parameter (nxbin11=14)
      Integer nxbin12
	Parameter (nxbin12=14)
      Integer nxbin13
	Parameter (nxbin13=14)
      Integer nxbin14
	Parameter (nxbin14=14)
      Integer nxbin15
	Parameter (nxbin15=14)
      Integer nxbin16
	Parameter (nxbin16=14)
      Integer nxbin17
	Parameter (nxbin17=14)
	
	
      Real f2_1(nxbin1),f2_2(nxbin2),f2_3(nxbin3)
      Real ef2_1(nxbin1),ef2_2(nxbin2),ef2_3(nxbin3)
      Real eft_1(nxbin1),eft_2(nxbin2),eft_3(nxbin3)
      Real f2_4(nxbin4),f2_5(nxbin5),f2_6(nxbin6)
      Real ef2_4(nxbin4),ef2_5(nxbin5),ef2_6(nxbin6)
      Real eft_4(nxbin4),eft_5(nxbin5),eft_6(nxbin6)
      Real f2_7(nxbin7),f2_8(nxbin8),f2_9(nxbin9)
      Real ef2_7(nxbin7),ef2_8(nxbin8),ef2_9(nxbin9)
      Real eft_7(nxbin7),eft_8(nxbin8),eft_9(nxbin9)
      Real f2_10(nxbin10),f2_11(nxbin11),f2_12(nxbin12)
      Real ef2_10(nxbin10),ef2_11(nxbin11),ef2_12(nxbin12)
      Real eft_10(nxbin10),eft_11(nxbin11),eft_12(nxbin12)
      Real f2_13(nxbin13),f2_14(nxbin14),f2_15(nxbin15)
      Real ef2_13(nxbin13),ef2_14(nxbin14),ef2_15(nxbin15)
      Real eft_13(nxbin13),eft_14(nxbin14),eft_15(nxbin15)
      Real f2_16(nxbin16),f2_17(nxbin17)
      Real ef2_16(nxbin16),ef2_17(nxbin17) 
      Real eft_16(nxbin16),eft_17(nxbin17)
	
	
      Real eyy1(nf1),eyy2(nf2),eyy3(nf3)
      Real eyy4(nf3),eyy5(nf3),eyy6(nf2)
      Real eyy7(nf3),eyy8(nf3),eyy9(nf4)
      Real eyy10(nf3),eyy11(nf4),eyy12(nf3)
      Real eyy13(nf5),eyy14(nf5),eyy15(nf6)
      Real eyy16(nf6),eyy17(nf7)
      Real esy1(nf1),esy2(nf2),esy3(nf3)
      Real esy4(nf3),esy5(nf3),esy6(nf2)
      Real esy7(nf3),esy8(nf3),esy9(nf4)
      Real esy10(nf3),esy11(nf4),esy12(nf3)
      Real esy13(nf5),esy14(nf5),esy15(nf6)
      Real esy16(nf6),esy17(nf7)
      Real esyc1(nf1),esyc2(nf2),esyc3(nf3)
      Real esyc4(nf3),esyc5(nf3),esyc6(nf2)
      Real esyc7(nf3),esyc8(nf3),esyc9(nf4)
      Real esyc10(nf3),esyc11(nf4),esyc12(nf3)
      Real esyc13(nf5),esyc14(nf5),esyc15(nf6)
      Real esyc16(nf6),esyc17(nf7)
*
* f2 data from H1 EPJ C21,33 (2001) 3 DESY 00-181
*    f2 Q2=1.5 (bin 1)
      Data xx1/0.000032,0.000050,0.000080/
      Data yy1/0.832,0.752,0.702/
      Data eyy1/0.011,0.014,0.029/
      Data esy1/0.029,0.029,0.048/
      Data esyc1/0.033,0.017,0.022/

*    f2 Q2=2.0 (bin 2)
c      Data xx2/0.0000327, 0.000050,0.000080,0.000130,0.000200,
      Data xx2/0.00002, 0.000050,0.000080,0.000130,0.000200,
     &         0.000320,0.000500,0.001000,0.003200/
      Data yy2/      0., 0.851,   0.748,   0.716,   0.654,
     &         0.626,0.620,0.513,0.424/
      Data eyy2/0,0.008,0.007,0.009,0.008,0.009,0.009,0.006,0.006/
      Data esy2/0,0.024,0.020,0.021,0.020,0.019,0.020,0.015,0.018/
      Data esyc2/0,0.016,0.015,0.013,0.022,0.018,0.029,0.016,0.020/
*    f2 Q2=2.5 (bin 3)
c      Data xx3/0.0000409,0.000050,0.000080,0.000130,0.000200,
      Data xx3/0.00003,0.000050,0.000080,0.000130,0.000200,
     &         0.000320,0.000500,0.000800,0.001580,0.005000 /
      Data yy3/0,0.909,0.828,0.767,0.691,0.638,0.603,0.555,0.516,0.403/
      Data eyy3/0,0.012,0.007,0.007,0.007,0.006,0.006,0.006,0.004,0.004/
      Data esy3/0,0.020,0.015,0.012,0.019,0.017,0.016,0.015,0.013,0.016/
      Data esyc3/0,0.025,0.014,0.013,0.008,0.009,0.005,0.006,0.006,
     &	0.013/
*    f2 Q2=3.5 (bin 4)
      Data xx4/0.0000573,0.000080,0.000130,0.000200,0.000320,
     &         0.000500,0.000800,0.001300,0.002510,0.008000/
      Data yy4/0,0.964,0.886,0.826,0.761,0.716,0.647,0.601,0.532,0.418/
      Data eyy4/0,0.011,0.008,0.007,0.008,0.007,0.006,0.006,0.004,0.004/
      Data esy4/0,0.017,0.013,0.012,0.012,0.011,0.011,0.010,0.008,0.014/
      Data esyc4/0,0.020,0.012,0.012,0.013,0.014,0.009,0.010,0.006,
     &	0.010/

*    f2 Q2=5 (bin 5)
      Data xx5/0.0000818,0.000130,0.000200,0.000320,0.000500,0.000800,
     &	   0.001300,0.002000,0.003980,0.013000/
      Data yy5/0,1.043,0.974,0.890,0.792,0.704,0.661,0.621,0.538,0.410/
      Data eyy5/0,0.011,0.010,0.010,0.009,0.008,0.007,0.007,0.005,0.004/
      Data esy5/0,0.018,0.014,0.014,0.013,0.011,0.011,0.010,0.008,0.013/
      Data esyc5/0,0.015,0.015,0.013,0.011,0.011,0.015,0.009,0.008,
     &	0.009/

*    f2 Q2=6.5 (bin 6)
      Data xx6/0.000130,0.000200,0.000320,0.000500,0.000800,
     &	0.001300,0.002000,0.003980,0.013000/
      Data yy6/1.148,1.092,0.963,0.877,0.801,0.708,0.672,0.587,0.432/
      Data eyy6/0.018,0.012,0.012,0.011,0.010,0.008,0.009,0.005,0.004/
      Data esy6/0.020,0.017,0.013,0.013,0.012,0.011,0.011,0.008,0.014/
      Data esyc6/0.030,0.014,0.012,0.016,0.012,0.010,0.011,0.009,0.006/

*    f2 Q2=8.5 (bin 7)
      Data xx7/0.000139,0.000200,0.000320,0.000500,0.000800,0.001300,
     &	0.002000,0.003200,0.006310,0.020000/
      Data yy7/0,1.193,1.092,0.996,0.894,0.797,0.725,0.632,0.565,0.419/
      Data eyy7/0,0.017,0.014,0.013,0.013,0.011,0.010,0.009,0.006,0.005/
      Data esy7/0,0.019,0.016,0.014,0.013,0.013,0.012,0.010,0.008,0.013/
      Data esyc7/0,0.024,0.017,0.013,0.013,0.014,0.013,0.011,0.007,
     &	0.010/
*    f2 Q2=12 (bin 8)
      Data xx8/0.000161,0.000197,0.00032,0.0005,
     &         0.000800,0.001300,0.002000,0.003200,0.006310,0.020000/
      Data yy8/0,0,1.249,1.156,
     &         0.989,0.879,0.825,0.725,0.613,0.459 /
      Data eyy8/0,0,0.007,0.008,
     &	0.016,0.014,0.013,0.012,0.007,0.006/
      Data esy8/0,0,0.021,0.016,
     &	0.016,0.014,0.013,0.012,0.009,0.015/
      Data esyc8/0,0,0.012,0.012,
     &	0.015,0.005,0.012,0.012,0.009,0.009/
*    f2 Q2=15 (bin 9)
c      Data xx9/0.000201,0.000246,
c     &	0.000320,0.000500,0.000800,0.001300,0.002000,0.003200,
c     &	0.005000,0.010000,0.032000/
      Data xx9/0.000101,0.00015,
     &	0.000320,0.000500,0.000800,0.001300,0.002000,0.003200,
     &	0.005000,0.010000,0.032000/
      Data yy9/0,0,
     &      1.342,1.247,1.121,0.971,0.866,0.774,0.708,0.575,0.453/
      Data eyy9/0,0,
     &	0.009,0.007,0.007,0.006,0.005,0.005,0.006,0.004,0.005/
      Data esy9/0,0,
     &	0.025,0.020,0.016,0.014,0.013,0.012,0.011,0.008,0.015/
      Data esyc9/0,0,
     &	0.019,0.009,0.009,0.023,0.017,0.015,0.012,0.013,0.025/
*    f2 Q2=20 (bin 10)
      Data xx10/0.000268,0.000328,
     &	0.000500,0.000800,0.001300,0.002000,0.003200,0.005000,
     &	0.010000,0.032000/
      Data yy10/0,0,
     &	1.324,1.190,1.062,0.940,0.819,0.747,0.610,0.455/
      Data eyy10/0,0,
     &	0.008,0.007,0.006,0.007,0.006,0.006,0.004,0.005/
      Data esy10/0,0,
     &	0.021,0.017,0.015,0.013,0.012,0.011,0.009,0.015/
      Data esyc10/0,0,
     &	0.012,0.012,0.011,0.022,0.014,0.010,0.011,0.027/
*    f2 Q2=25 (bin 11)
c      Data xx11/0.000335,0.000410,
      Data xx11/0.00016,0.000310,
     &	0.000500,0.000800,0.001300,0.002000,0.003200,0.005000,
     &	0.008000,0.015800,0.050000/
      Data yy11/0,0,
     &	1.417,1.263,1.097,0.987,0.880,0.754,0.663,0.547,0.447/
      Data eyy11/0,0,
     &	0.014,0.009,0.008,0.008,0.007,0.007,0.006,0.005,0.006/
      Data esy11/0,0,
     &	0.026,0.020,0.015,0.014,0.013,0.011,0.010,0.008,0.015/
      Data esyc11/0,0,
     &	0.017,0.011,0.010,0.024,0.019,0.012,0.012,0.018,0.030/
*    f2 Q2=35 (bin 12)
c      Data xx12/0.000574,
c     &	0.000800,0.001300,0.002000,0.003200,0.005000,0.008000,
c     &	0.013000,0.025100,0.080000/
      Data xx12/0.00044,
     &	0.000800,0.001300,0.002000,0.003200,0.005000,0.008000,
     &	0.013000,0.025100,0.080000/
      Data yy12/0,
     &	1.405,1.195,1.035,0.936,0.821,0.719,0.625,0.524,0.413/
      Data eyy12/0,
     &	0.013,0.010,0.008,0.008,0.007,0.007,0.007,0.006,0.007/
      Data esy12/0,
     &	0.024,0.017,0.014,0.014,0.012,0.011,0.010,0.008,0.014/
      Data esyc12/0,
     &	0.015,0.010,0.008,0.023,0.016,0.012,0.016,0.019,0.034/
*    f2 Q2=45 (bin 13)
      Data xx13/0.001300,0.002000,0.003200,0.005000,0.008000,0.013000,
     &	0.025100,0.080000/
      Data yy13/1.309,1.115,0.982,0.873,0.743,0.649,0.525,0.396/
      Data eyy13/0.012,0.010,0.009,0.010,0.008,0.008,0.006,0.008/
      Data esy13/0.022,0.016,0.014,0.013,0.011,0.010,0.008,0.014/
      Data esyc13/0.004,0.007,0.007,0.018,0.012,0.013,0.020,0.025/
*    f2 Q2=60 (bin 14)
      Data xx14/0.002000,0.003200,0.005000,0.008000,0.013000,0.020000,
     &	0.039800,0.130000/
      Data yy14/1.263,1.057,0.902,0.804,0.683,0.597,0.506,0.360/
      Data eyy14/0.013,0.012,0.011,0.010,0.010,0.010,0.009,0.011/
      Data esy14/0.021,0.015,0.014,0.013,0.012,0.011,0.010,0.014/
      Data esyc14/0.009,0.0075,0.021,0.015,0.014,0.019,0.020,0.029/
*    f2 Q2=90 (bin 15)
      Data xx15/0.003200,0.005000,0.008000,0.013000,0.020000,0.039800,
     &	0.130000/
      Data yy15/1.120,1.004,0.846,0.728,0.618,0.506,0.339/
      Data eyy15/0.016,0.013,0.013,0.012,0.011,0.010,0.011/
      Data esy15/0.020,0.015,0.014,0.013,0.012,0.010,0.007/
      Data esyc15/0.013,0.009,0.021,0.010,0.017,0.014,0.010/
*    f2 Q2=120 (bin 16)
      Data xx16/0.005000,0.008000,0.013000,0.020000,0.032000,0.063100,
     &	0.200000/
      Data yy16/1.019,0.841,0.745,0.605,0.558,0.462,0.312/
      Data eyy16/0.024,0.016,0.016,0.014,0.016,0.014,0.015/
      Data esy16/0.021,0.015,0.015,0.013,0.014,0.012,0.015/
      Data esyc16/0.019,0.012,0.027,0.015,0.025,0.013,0.026/
*    f2 Q2=150 (bin 17)
      Data xx17/0.020000,0.032000,0.063100,0.200000/
      Data yy17/0.709,0.550,0.418,0.296/
      Data eyy17/0.031,0.028,0.024,0.025/
      Data esy17/0.027,0.023,0.018,0.021/
      Data esyc17/0.047,0.026,0.023,0.020/

      
	Real myqbin(21)
c      Data myqbin/1.,1.7,2.2,3.,4.,6.,7.,10.,14.,16.,22.,28.,40.,
c     & 50.,70.,100.,135.,200./
      Data myqbin/1.25,1.8,2.25,2.8,4.4,5.8,7.34,9.9,14.7,15.5,18.4,
     & 22.0,29.,31.,40.,51.,72.,78.,105.,139.,165./
      Real q2b(17)
c      data q2b/1.5,2.5,3.5,5.,6.5,8.5,12.,15.,20.,25.,35.,45.,60.,90./
      data q2b/1.5,2.0,2.5,3.5,5.,6.5,8.5,12.,15.,20.,25.,35.,45.,60.,
     &	90.,120.,150./
      Real q2binw(17)
      Real xcenter(nxbin+2),xbin(nxbin+1)
      Data xcenter/0.0000032,0.000005, 0.000008, 0.000013, 0.00002,
     +             0.000032, 0.00005,  0.00008,  0.00013,  0.0002,
     +             0.00032,  0.0005,   0.0008,   0.0013,   0.002,
     +             0.0025, 0.0032,
     +             0.004,   0.005, 0.0063,   0.008,    0.013,    0.02,
     +             0.032,    0.05,     0.08, 0.13, 0.2/
      Real xcent1(nxbin1+2),xbin1(nxbin1+1)
	Data xcent1/0.00002, 0.000032,0.00005,0.00008,0.00013,0.0002,
     +                     0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	               0.0032,  0.005,  0.008,  0.013,  0.02/
      Real xcent2(nxbin2+2),xbin2(nxbin2+1)
	Data xcent2/0.00001, 0.00002,0.00005,0.00008,0.00013,0.0002,
     +                     0.00032, 0.0005, 0.001,  
     +	               0.0032,  0.007,  0.02,  0.04,  0.08/
      Real xcent3(nxbin3+2),xbin3(nxbin3+1)
	Data xcent3/0.00002, 0.00003, 0.00005,0.00008,0.00013,0.0002,
     +                     0.00032, 0.0005, 0.0008, 0.00158,  
     +	                        0.005,  0.008,  0.015,  0.04/
      Real xcent4(nxbin4+2),xbin4(nxbin4+1)
	Data xcent4/0.00002, 0.000032,0.0000573,0.00008,0.00013,0.0002,
     +                     0.00032, 0.0005,   0.0008, 0.0013, 0.00251, 
     +	                                  0.008,  0.013,  0.02/
      Real xcent5(nxbin5+2),xbin5(nxbin5+1)
	Data xcent5/0.000032,0.00005,0.0000818,0.00013,0.0002,
     +                     0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	               0.00398,         0.013,  0.02,0.5/
     
      Real xcent6(nxbin6+2),xbin6(nxbin6+1)
	Data xcent6/0.000032,0.00005,0.00008,0.00013,0.0002,
     +                     0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	               0.00398,         0.013,  0.02,0.5/
     
      Real xcent7(nxbin7+2),xbin7(nxbin7+1)
	Data xcent7/ 0.00005,0.00008,0.000139,0.0002,
     +                     0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	               0.0032,  0.00631,         0.02,0.05,1./
     
      Real xcent8(nxbin8+2),xbin8(nxbin8+1)
c	Data xcent8/0.00006,0.00008,0.000161,0.000197,
	Data xcent8/0.00006,0.0001,0.000161,0.000197,
     +                     0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	        0.0032,  0.00631,                 0.02,0.05,1./
     
      Real xcent9(nxbin9+2),xbin9(nxbin9+1)
	Data xcent9/ 0.00004,0.00006,0.00008,0.000101,
     +            0.00015,0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	      0.0032,  0.005,  0.01,    0.032  ,0.06,1./
     
      Real xcent10(nxbin10+2),xbin10(nxbin10+1)
	Data xcent10/0.00005,0.00008,0.00016,0.000268,
     +                     0.000328, 0.0005, 0.0008, 0.0013, 0.002, 
     +	      0.0032,  0.005,  0.01,            0.032,0.06,1./
     
      Real xcent11(nxbin11+2),xbin11(nxbin11+1)
c	Data xcent11/0.00008,0.00013,0.0002,
c     +             0.000335, 0.00041, 0.0005, 0.0008, 0.0013, 0.002, 
c     +	       0.0032,  0.005,  0.008, 0.0158, 0.05,0.09,0.5/

ccc     +             0.00028, 0.00041, 0.0005, 0.0008, 0.0013, 0.002, 
     
 	Data xcent11/0.00005,0.00008,0.00012,
     +             0.00016, 0.00031, 0.0005, 0.0008, 0.0013, 0.002, 
     +	       0.0032,  0.005,  0.008, 0.0158, 0.05,0.09,0.5/
     
      Real xcent12(nxbin12+2),xbin12(nxbin12+1)
	Data xcent12/                                 0.00013,0.0002,
     +                     0.00032, 0.00044, 0.0008, 0.0013, 0.002, 
     +	               0.0032,  0.005,  0.008,  0.013,  0.0251,
     +                                      0.08,   0.13,   0.2 , 0.5/
     
      Real xcent13(nxbin13+2),xbin13(nxbin13+1)
	Data xcent13/                                 0.00013,0.0002,
     +                     0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	               0.0032,  0.005,  0.008,  0.013,  0.0251,
     +                              0.08,   0.13,   0.2 , 0.5/
     
      Real xcent14(nxbin14+2),xbin14(nxbin14+1)
	Data xcent14/                                 0.00013,0.0002,
     +                     0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	               0.0032,  0.005,  0.008,  0.013,  0.02,
     +                              0.0398, 0.13,   0.2 , 0.5/


      Real xcent15(nxbin15+2),xbin15(nxbin15+1)
	Data xcent15/                                 0.00013,0.0002,
     +                     0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	               0.0032,  0.005,  0.008,  0.013,  0.02,
     +                                      0.0398, 0.13,   0.2 , 0.5/

      Real xcent16(nxbin16+2),xbin16(nxbin16+1)
	Data xcent16/                                0.0002,
     +                     0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	               0.0032,  0.005,  0.008,  0.013,  0.02,
     +                     0.032,  0.0631,  0.2 , 0.5, 1.0/

      Real xcent17(nxbin17+2),xbin17(nxbin17+1)
	Data xcent17/                                 0.0002,
     +                     0.00032, 0.0005, 0.0008, 0.0013, 0.002, 
     +	               0.0032,  0.005,  0.008,  0.013,  0.02,
     +                     0.032,  0.0631,  0.2 , 0.5, 1.0/


     

c      Real conten(nxbin),contene(nxbin)
	
	Real q2bin(17)
	Real nq2bin(17)

      Real xkt1,xkt2,x1,x2
      Integer igl1,igl2
      save Qpi, qqradp, first, xbin, xbin1, xbin2, xbin3, xbin4, xbin5,
     &     xbin6, xbin7, xbin8, xbin9, xbin10, xbin11, xbin12, xbin13, 
     &     xbin14, xbin15, xbin16, xbin17, iqbin, q2binw

      save nall, nall2

*
****************************************************************************
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"
*
      Integer iflag,ihep,i,j,k,l,idhist
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'00181'/
*
	Double precision chi
	Integer ndf
	Double precision chit
	Integer ndft
	Common/fit/chit,ndft
	Logical First
	Data First/.true./
      real conten(nxbin)
      real sigm,wt
      common/cwnco1/x,y,Q2,sigm,wt
	integer jqbin(20)
	data jqbin/1,2,3,4,5,6,7,8,9,0,10,11,0,12,13,14,0,15,16,17/
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
c         write(6,*)' hz00181 my private Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
	   first = .false.
	   Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*
         do I = 1,nxbin+1
            xbin(i) = xcenter(i) + (xcenter(i+1)-xcenter(i))/2.
         enddo

         xbin1(1)=xcent1(1)-(xcent1(2)-xcent1(1))/20.
         do I = 1,nxbin1
            xbin1(i+1) = 2*xcent1(i) - xbin1(i)
         enddo
         xbin2(1)=xcent2(1)-(xcent2(2)-xcent2(1))/20.
         do I = 1,nxbin2
            xbin2(i+1) = 2*xcent2(i) - xbin2(i)
         enddo
         xbin3(1)=xcent3(1)-(xcent3(2)-xcent3(1))/20.
         do I = 1,nxbin3
            xbin3(i+1) = 2*xcent3(i) - xbin3(i)
         enddo
         xbin4(1)=xcent4(1)-(xcent4(2)-xcent4(1))/20.
         do I = 1,nxbin4
            xbin4(i+1) = 2*xcent4(i) - xbin4(i)
         enddo
         xbin5(1)=xcent5(1)-(xcent5(2)-xcent5(1))/20.
         do I = 1,nxbin5
            xbin5(i+1) = 2*xcent5(i) - xbin5(i)
         enddo
         xbin6(1)=xcent6(1)-(xcent6(2)-xcent6(1))/20.
         do I = 1,nxbin6
            xbin6(i+1) = 2*xcent6(i) - xbin6(i)
         enddo
         xbin7(1)=xcent7(1)-(xcent7(2)-xcent7(1))/20.
         do I = 1,nxbin7
            xbin7(i+1) = 2*xcent7(i) - xbin7(i)
         enddo
         xbin8(1)=xcent8(1)-(xcent8(2)-xcent8(1))/20.
         do I = 1,nxbin8
            xbin8(i+1) = 2*xcent8(i) - xbin8(i)
         enddo
         xbin9(1)=xcent9(1)-(xcent9(2)-xcent9(1))/20.
         do I = 1,nxbin9
            xbin9(i+1) = 2*xcent9(i) - xbin9(i)
         enddo
         xbin10(1)=xcent10(1)-(xcent10(2)-xcent10(1))/20.
         do I = 1,nxbin10
            xbin10(i+1) = 2*xcent10(i) - xbin10(i)
         enddo
         xbin11(1)=xcent11(1)-(xcent11(2)-xcent11(1))/20.
         do I = 1,nxbin11
            xbin11(i+1) = 2*xcent11(i) - xbin11(i)
         enddo
         xbin12(1)=xcent12(1)-(xcent12(2)-xcent12(1))/20.
         do I = 1,nxbin12
            xbin12(i+1) = 2*xcent12(i) - xbin12(i)
         enddo
         xbin13(1)=xcent13(1)-(xcent13(2)-xcent13(1))/20.
         do I = 1,nxbin13
            xbin13(i+1) = 2*xcent13(i) - xbin13(i)
         enddo
         xbin14(1)=xcent14(1)-(xcent14(2)-xcent14(1))/20.
         do I = 1,nxbin14
            xbin14(i+1) = 2*xcent14(i) - xbin14(i)
         enddo
         xbin15(1)=xcent15(1)-(xcent15(2)-xcent15(1))/20.
         do I = 1,nxbin15
            xbin15(i+1) = 2*xcent15(i) - xbin15(i)
         enddo
         xbin16(1)=xcent16(1)-(xcent16(2)-xcent16(1))/20.
         do I = 1,nxbin16
            xbin16(i+1) = 2*xcent16(i) - xbin16(i)
         enddo
         xbin17(1)=xcent17(1)-(xcent17(2)-xcent17(1))/20.
         do I = 1,nxbin17
            xbin17(i+1) = 2*xcent17(i) - xbin17(i)
         enddo



         do i=1,20
		iqbin = jqbin(i)
		if(iqbin.ne.0) then 
		  q2binw(iqbin)=myqbin(i+1)-myqbin(i)
		endif
c		write(6,*) ' q2binw ',j,q2binw(j),myqbin(i+1),myqbin(i)
         enddo
	   do I=1,nxbin1
c	   write(6,*) ' xbinc 1',xbin1(i),xcent1(i)
	   enddo
c	   write(6,*) ' xbinc 1 +1,+2',xbin1(nxbin1+1),xbin1(nxbin1+2) 
	   do I=1,nxbin2
c     	   write(6,*) ' xbinc 2',xbin2(i),xcent2(i)
	   enddo
c	   write(6,*) ' xbinc 2 +1,+2',xbin2(nxbin2+1),xbin2(nxbin2+2) 
	   do I=1,nxbin3
c	   write(6,*) ' xbinc 3',xbin3(i),xcent3(i)
	   enddo
c	   write(6,*) ' xbinc 3 +1,+2',xbin3(nxbin3+1),xbin3(nxbin3+2) 
	   do I=1,nxbin4
c	   write(6,*) ' xbinc 4',xbin4(i),xcent4(i)
	   enddo
c	   write(6,*) ' xbinc 4 +1,+2',xbin4(nxbin4+1),xbin4(nxbin4+2) 
	   do I=1,nxbin8
c	   write(6,*) ' xbinc 8',xbin8(i),xcent8(i)
	   enddo
c	   write(6,*) ' xbinc 8 +1,+2',xbin8(nxbin8+1),xbin8(nxbin8+2) 
	   do I=1,nxbin9
c	   write(6,*) ' xbinc 9',xbin9(i),xcent9(i)
	   enddo
c	   write(6,*) ' xbinc 9 +1,+2',xbin9(nxbin9+1),xbin9(nxbin9+2) 
	   do I=1,nxbin10
c	   write(6,*) ' xbinc 10',xbin10(i),xcent10(i)
	   enddo
c	  write(6,*) ' xbinc 10 +1,+2',xbin10(nxbin10+1),xbin10(nxbin10+2) 
	   do I=1,nxbin11
c	   write(6,*) ' xbinc 11',xbin11(i),xcent11(i)
	   enddo
c	  write(6,*) ' xbinc 11 +1,+2',xbin11(nxbin11+1),xbin11(nxbin11+2) 
*****************************
*  Make histograms of F2 , F2CC and F2CC/F2 for pure PDF function
*****************************
*
c         CALL HBNT(1999,'smallx  ',' ')
c         CALL HBNAME (1999,'kin',x,'x,y,Q2,sigm,wt')

         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,100.,0.)
         call hbookb( 1001,'f2 Q2=1.5 ',nxbin1,xbin1,0.)
         call hbookb( 1002,'f2 Q2=2.0 ',nxbin2,xbin2,0.)
         call hbookb( 1003,'f2 Q2=2.5 ',nxbin3,xbin3,0.)
         call hbookb( 1004,'f2 Q2=3.5 ',nxbin4,xbin4,0.)
         call hbookb( 1005,'f2 Q2=5.0 ',nxbin5,xbin5,0.)
         call hbookb( 1006,'f2 Q2=6.5 ',nxbin6,xbin6,0.)
         call hbookb( 1007,'f2 Q2=8.5 ',nxbin7,xbin7,0.)
         call hbookb( 1008,'f2 Q2=12. ',nxbin8,xbin8,0.)
         call hbookb( 1009,'f2 Q2=15. ',nxbin9,xbin9,0.)
         call hbookb( 1010,'f2 Q2=20. ',nxbin10,xbin10,0.)
         call hbookb( 1011,'f2 Q2=25. ',nxbin11,xbin11,0.)
         call hbookb( 1012,'f2 Q2=35. ',nxbin12,xbin12,0.)
         call hbookb( 1013,'f2 Q2=45. ',nxbin13,xbin13,0.)
         call hbookb( 1014,'f2 Q2=60. ',nxbin14,xbin14,0.)
         call hbookb( 1015,'f2 Q2=90. ',nxbin15,xbin15,0.)
         call hbookb( 1016,'f2 Q2=120. ',nxbin16,xbin16,0.)
         call hbookb( 1017,'f2 Q2=150. ',nxbin17,xbin17,0.)

	   do I=1001,1017
	   call hbarx(i)
         enddo

c         call hbookb( 2001,'f2 Q2=1.5 pdf ',nxbin,xbin,0.)
c         call hbookb( 2002,'f2 Q2=2.0 pdf ',nxbin,xbin,0.)
c         call hbookb( 2003,'f2 Q2=2.5 pdf ',nxbin,xbin,0.)
c         call hbookb( 2004,'f2 Q2=3.5 pdf ',nxbin,xbin,0.)
c         call hbookb( 2005,'f2 Q2=5.0 pdf ',nxbin,xbin,0.)
c         call hbookb( 2006,'f2 Q2=6.5 pdf ',nxbin,xbin,0.)
c         call hbookb( 2007,'f2 Q2=8.5 pdf ',nxbin,xbin,0.)
c         call hbookb( 2008,'f2 Q2=12. pdf ',nxbin,xbin,0.)
c         call hbookb( 2009,'f2 Q2=15. pdf ',nxbin,xbin,0.)
c         call hbookb( 2010,'f2 Q2=20. pdf ',nxbin,xbin,0.)
c         call hbookb( 2011,'f2 Q2=25. pdf ',nxbin,xbin,0.)
c         call hbookb( 2012,'f2 Q2=35. pdf ',nxbin,xbin,0.)
c         call hbookb( 2013,'f2 Q2=45. pdf ',nxbin,xbin,0.)
c         call hbookb( 2014,'f2 Q2=60. pdf ',nxbin,xbin,0.)
c         call hbookb( 2015,'f2 Q2=90. pdf ',nxbin,xbin,0.)
c         call hbookb( 2016,'f2 Q2=120. pdf ',nxbin,xbin,0.)
c         call hbookb( 2017,'f2 Q2=150. pdf ',nxbin,xbin,0.)
         call hbookb( 2001,'f2 Q2=1.5 pdf ',nxbin1,xbin1,0.)
         call hbookb( 2002,'f2 Q2=2.0 pdf ',nxbin2,xbin2,0.)
         call hbookb( 2003,'f2 Q2=2.5 pdf ',nxbin3,xbin3,0.)
         call hbookb( 2004,'f2 Q2=3.5 pdf ',nxbin4,xbin4,0.)
         call hbookb( 2005,'f2 Q2=5.0 pdf ',nxbin5,xbin5,0.)
         call hbookb( 2006,'f2 Q2=6.5 pdf ',nxbin6,xbin6,0.)
         call hbookb( 2007,'f2 Q2=8.5 pdf ',nxbin7,xbin7,0.)
         call hbookb( 2008,'f2 Q2=12. pdf ',nxbin8,xbin8,0.)
         call hbookb( 2009,'f2 Q2=15. pdf ',nxbin9,xbin9,0.)
         call hbookb( 2010,'f2 Q2=20. pdf ',nxbin10,xbin10,0.)
         call hbookb( 2011,'f2 Q2=25. pdf ',nxbin11,xbin11,0.)
         call hbookb( 2012,'f2 Q2=35. pdf ',nxbin12,xbin12,0.)
         call hbookb( 2013,'f2 Q2=45. pdf ',nxbin13,xbin13,0.)
         call hbookb( 2014,'f2 Q2=60. pdf ',nxbin14,xbin14,0.)
         call hbookb( 2015,'f2 Q2=90. pdf ',nxbin15,xbin15,0.)
         call hbookb( 2016,'f2 Q2=120. pdf ',nxbin16,xbin16,0.)
         call hbookb( 2017,'f2 Q2=150. pdf ',nxbin17,xbin17,0.)


         call hbookb( -1001,'f2 Q2=1.5 data stat',nxbin1,xbin1,0.)
         call hbookb( -1101,'f2 Q2=1.5 data tot',nxbin1,xbin1,0.)
         call hbookb( -1002,'f2 Q2=2.0 data stat',nxbin2,xbin2,0.)
         call hbookb( -1102,'f2 Q2=2.0 data tot',nxbin2,xbin2,0.)
         call hbookb( -1003,'f2 Q2=2.5 data stat',nxbin3,xbin3,0.)
         call hbookb( -1103,'f2 Q2=2.5 data tot',nxbin3,xbin3,0.)
         call hbookb( -1004,'f2 Q2=3.5 data stat',nxbin4,xbin4,0.)
         call hbookb( -1104,'f2 Q2=3.5 data tot',nxbin4,xbin4,0.)
         call hbookb( -1005,'f2 Q2=5.0 data stat',nxbin5,xbin5,0.)
         call hbookb( -1105,'f2 Q2=5.0 data tot',nxbin5,xbin5,0.)
         call hbookb( -1006,'f2 Q2=6.5 data stat',nxbin6,xbin6,0.)
         call hbookb( -1106,'f2 Q2=6.5 data tot',nxbin6,xbin6,0.)
         call hbookb( -1007,'f2 Q2=8.5 data stat',nxbin7,xbin7,0.)
         call hbookb( -1107,'f2 Q2=8.5 data tot',nxbin7,xbin7,0.)
         call hbookb( -1008,'f2 Q2=12. data stat',nxbin8,xbin8,0.)
         call hbookb( -1108,'f2 Q2=12. data tot',nxbin8,xbin8,0.)
         call hbookb( -1009,'f2 Q2=15. data stat',nxbin9,xbin9,0.)
         call hbookb( -1109,'f2 Q2=15. data tot',nxbin9,xbin9,0.)
         call hbookb( -1010,'f2 Q2=20. data stat',nxbin10,xbin10,0.)
         call hbookb( -1110,'f2 Q2=20. data tot',nxbin10,xbin10,0.)
         call hbookb( -1011,'f2 Q2=25. data stat',nxbin11,xbin11,0.)
         call hbookb( -1111,'f2 Q2=25. data tot',nxbin11,xbin11,0.)
         call hbookb( -1012,'f2 Q2=35. data stat',nxbin12,xbin12,0.)
         call hbookb( -1112,'f2 Q2=35. data tot',nxbin12,xbin12,0.)
         call hbookb( -1013,'f2 Q2=45. data stat',nxbin13,xbin13,0.)
         call hbookb( -1113,'f2 Q2=45. data tot',nxbin13,xbin13,0.)
         call hbookb( -1014,'f2 Q2=60. data stat',nxbin14,xbin14,0.)
         call hbookb( -1114,'f2 Q2=60. data tot',nxbin14,xbin14,0.)
         call hbookb( -1015,'f2 Q2=90. data stat',nxbin15,xbin15,0.)
         call hbookb( -1115,'f2 Q2=90. data tot',nxbin15,xbin15,0.)
         call hbookb( -1016,'f2 Q2=120. data stat',nxbin16,xbin16,0.)
         call hbookb( -1116,'f2 Q2=120. data tot',nxbin16,xbin16,0.)
         call hbookb( -1017,'f2 Q2=150. data stat',nxbin17,xbin17,0.)
         call hbookb( -1117,'f2 Q2=150. data tot',nxbin17,xbin17,0.)

c         call hbook1(31,' beam2 log(xg) (all)',50,-5,0.,0.)
c         call hbook1(32,' beam2 kt_2 (all)',50,0.,10.,0.)
*



         j=1
         Do i =1,nxbin1
            f2_1(i)=0.
            if(j.le.nf1) then
c		   write(6,*) ' xcent1 ',xcent1(i),xx1(j)
c               if(xcent1(i+1).eq.xx1(j)) then
               if(xcent1(i).eq.xx1(j)) then
                  f2_1(i)=yy1(j)
                  ef2_1(i)=eyy1(j)
                  eft_1(i) = sqrt(eyy1(j)**2 + esy1(j)**2 + esyc1(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin2
            f2_2(i)=0.
            if(j.le.nf2) then
c		   write(6,*) ' xcent2 ',xcent2(i),xx2(j)
c               if(xcent2(i+1).eq.xx2(j)) then
               if(xcent2(i).eq.xx2(j)) then
                  f2_2(i)=yy2(j)
                  ef2_2(i)=eyy2(j)
                  eft_2(i) = sqrt(eyy2(j)**2 + esy2(j)**2 + esyc2(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin3
            f2_3(i)=0.
            if(j.le.nf3) then
c		   write(6,*) ' xcent3 ',xcent3(i),xx3(j)
c               if(xcent3(i+1).eq.xx3(j)) then
               if(xcent3(i).eq.xx3(j)) then
                  f2_3(i)=yy3(j)
                  ef2_3(i)=eyy3(j)
                  eft_3(i) = sqrt(eyy3(j)**2 + esy3(j)**2 + esyc3(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin4
            f2_4(i)=0.
            if(j.le.nf3) then
c		   write(6,*) ' xcent4 ',xcent4(i),xx4(j)
c               if(xcent4(i+1).eq.xx4(j)) then
               if(xcent4(i).eq.xx4(j)) then
                  f2_4(i)=yy4(j)
                  ef2_4(i)=eyy4(j)
                  eft_4(i) = sqrt(eyy4(j)**2 + esy4(j)**2 + esyc4(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin5
            f2_5(i)=0.
c		   write(6,*) ' xcent5 ',xcent5(i),xx5(j),nf3
            if(j.le.nf3) then
c               if(xcent5(i+1).eq.xx5(j)) then
               if(xcent5(i).eq.xx5(j)) then
                  f2_5(i)=yy5(j)
                  ef2_5(i)=eyy5(j)
                  eft_5(i) = sqrt(eyy5(j)**2 + esy5(j)**2 + esyc5(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6
            f2_6(i)=0.
            if(j.le.nf2) then
c		   write(6,*) ' xcent6 ',xcent6(i),xx6(j)
c               if(xcent6(i+1).eq.xx6(j)) then
                if(xcent6(i).eq.xx6(j)) then
                 f2_6(i)=yy6(j)
                  ef2_6(i)=eyy6(j)
                  eft_6(i) = sqrt(eyy6(j)**2 + esy6(j)**2 + esyc6(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin7
            f2_7(i)=0.
            if(j.le.nf3) then
c		   write(6,*) ' xcent7 ',xcent7(i),xx7(j)
c               if(xcent7(i+1).eq.xx7(j)) then
               if(xcent7(i).eq.xx7(j)) then
                  f2_7(i)=yy7(j)
                  ef2_7(i)=eyy7(j)
                  eft_7(i) = sqrt(eyy7(j)**2 + esy7(j)**2 + esyc7(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin8
            f2_8(i)=0.
            if(j.le.nf3) then
c		   write(6,*) ' xcent8 ',xcent8(i),xx8(j)
c               if(xcent8(i+1).eq.xx8(j)) then
               if(xcent8(i).eq.xx8(j)) then
                  f2_8(i)=yy8(j)
                  ef2_8(i)=eyy8(j)
                  eft_8(i) = sqrt(eyy8(j)**2 + esy8(j)**2 + esyc8(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin9
            f2_9(i)=0.
            if(j.le.nf4) then
c		   write(6,*) ' xcent9 ',xcent9(i),xx9(j)
c               if(xcent9(i+1).eq.xx9(j)) then
               if(xcent9(i).eq.xx9(j)) then
                  f2_9(i)=yy9(j)
                  ef2_9(i)=eyy9(j)
                  eft_9(i) = sqrt(eyy9(j)**2 + esy9(j)**2 + esyc9(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin10
            f2_10(i)=0.
            if(j.le.nf3) then
c		   write(6,*) ' xcent10 ',xcent10(i),xx10(j)
c               if(xcent10(i+1).eq.xx10(j)) then
               if(xcent10(i).eq.xx10(j)) then
                  f2_10(i)=yy10(j)
                  ef2_10(i)=eyy10(j)
                  eft_10(i) = sqrt(eyy10(j)**2+esy10(j)**2+esyc10(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin11
            f2_11(i)=0.
            if(j.le.nf4) then
c		   write(6,*) ' xcent11 ',xcent11(i),xx11(j)
c               if(xcent11(i+1).eq.xx11(j)) then
               if(xcent11(i).eq.xx11(j)) then
                  f2_11(i)=yy11(j)
                  ef2_11(i)=eyy11(j)
                  eft_11(i) = sqrt(eyy11(j)**2+esy11(j)**2+esyc11(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin12
            f2_12(i)=0.
            if(j.le.nf3) then
c		   write(6,*) ' xcent12 ',xcent12(i),xx12(j)
c               if(xcent12(i+1).eq.xx12(j)) then
               if(xcent12(i).eq.xx12(j)) then
                  f2_12(i)=yy12(j)
                  ef2_12(i)=eyy12(j)
                  eft_12(i) = sqrt(eyy12(j)**2+esy12(j)**2+esyc12(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin13
            f2_13(i)=0.
            if(j.le.nf5) then
c		   write(6,*) ' xcent13 ',xcent13(i),xx13(j)
c               if(xcent13(i+1).eq.xx13(j)) then
               if(xcent13(i).eq.xx13(j)) then
                  f2_13(i)=yy13(j)
                  ef2_13(i)=eyy13(j)
                  eft_13(i) = sqrt(eyy13(j)**2+esy13(j)**2+esyc13(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin14
            f2_14(i)=0.
            if(j.le.nf5) then
c		   write(6,*) ' xcent14 ',xcent14(i),xx14(j)
c               if(xcent14(i+1).eq.xx14(j)) then
               if(xcent14(i).eq.xx14(j)) then
                  f2_14(i)=yy14(j)
                  ef2_14(i)=eyy14(j)
                  eft_14(i) = sqrt(eyy14(j)**2+esy14(j)**2+esyc14(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin15
            f2_15(i)=0.
            if(j.le.nf6) then
c		   write(6,*) ' xcent15 ',xcent15(i),xx15(j)
c               if(xcent15(i+1).eq.xx15(j)) then
               if(xcent15(i).eq.xx15(j)) then
                  f2_15(i)=yy15(j)
                  ef2_15(i)=eyy15(j)
                  eft_15(i) = sqrt(eyy15(j)**2+esy15(j)**2+esyc15(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin16
            f2_16(i)=0.
            if(j.le.nf6) then
c		   write(6,*) ' xcent16 ',xcent16(i),xx16(j)
c               if(xcent16(i+1).eq.xx16(j)) then
               if(xcent16(i).eq.xx16(j)) then
                  f2_16(i)=yy16(j)
                  ef2_16(i)=eyy16(j)
                  eft_16(i) = sqrt(eyy16(j)**2+esy16(j)**2+esyc16(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin17
            f2_17(i)=0.
            if(j.le.nf7) then
c		   write(6,*) ' xcent17 ',xcent17(i),xx17(j)
c               if(xcent17(i+1).eq.xx17(j)) then
                if(xcent17(i).eq.xx17(j)) then
                 f2_17(i)=yy17(j)
                  ef2_17(i)=eyy17(j)
                  eft_17(i) = sqrt(eyy17(j)**2+esy17(j)**2+esyc17(j)**2)
                  j=j+1
               endif
            endif
         enddo



c         write(6,*) ' Q2 = 1.5 '
c         write(6,10001)
10001  format('  bin  |     x     |   F2   | ')
         do i=1,nxbin1
            if(f2_1(i).gt.0.0) then
c               write(6,10002) i,xcent1(i),f2_1(i)
            endif
         enddo
10002  format(i6,' | ',e9.4,' | ',f6.3,' |')
c         write(6,*) ' Q2 = 2.0 '
c         write(6,10001)
         do i=1,nxbin2
            if(f2_2(i).gt.0.0) then
c               write(6,10002) i,xcent2(i),f2_2(i)
            endif
         enddo
c         write(6,*) ' Q2 = 2.5 '
c         write(6,10001)
         do i=1,nxbin3
            if(f2_3(i).gt.0.0) then
c               write(6,10002) i,xcent3(i),f2_3(i)
            endif
         enddo
c         write(6,*) ' Q2 = 3.5 '
c         write(6,10001)
         do i=1,nxbin4
            if(f2_4(i).gt.0.0) then
c               write(6,10002) i,xcent4(i),f2_4(i)
            endif
         enddo
c         write(6,*) ' Q2 = 5 '
c         write(6,10001)
         do i=1,nxbin5
            if(f2_5(i).gt.0.0) then
c               write(6,10002) i,xcent5(i),f2_5(i)
            endif
         enddo
c         write(6,*) ' Q2 = 6.5 '
c         write(6,10001)
         do i=1,nxbin6
            if(f2_6(i).gt.0.0) then
c               write(6,10002) i,xcent6(i),f2_6(i)
            endif
         enddo
c         write(6,*) ' Q2 = 8.5 '
c         write(6,10001)
         do i=1,nxbin7
            if(f2_7(i).gt.0.0) then
c               write(6,10002) i,xcent7(i),f2_7(i)
            endif
         enddo
c         write(6,*) ' Q2 = 12 '
c         write(6,10001)
         do i=1,nxbin8
            if(f2_8(i).gt.0.0) then
c               write(6,10002) i,xcent8(i),f2_8(i)
            endif
         enddo
c         write(6,*) ' Q2 = 15 '
c         write(6,10001)
         do i=1,nxbin9
            if(f2_9(i).gt.0.0) then
c               write(6,10002) i,xcent9(i),f2_9(i)
            endif
         enddo
c         write(6,*) ' Q2 = 20 '
c         write(6,10001)
         do i=1,nxbin10
            if(f2_10(i).gt.0.0) then
c               write(6,10002) i,xcent10(i),f2_10(i)
            endif
         enddo
c         write(6,*) ' Q2 = 25 '
c         write(6,10001)
         do i=1,nxbin11
            if(f2_11(i).gt.0.0) then
c               write(6,10002) i,xcent11(i),f2_11(i)
            endif
         enddo
c         write(6,*) ' Q2 = 35 '
c         write(6,10001)
         do i=1,nxbin12
            if(f2_12(i).gt.0.0) then
c               write(6,10002) i,xcent12(i),f2_12(i)
            endif
         enddo
c         write(6,*) ' Q2 = 45 '
c         write(6,10001)
         do i=1,nxbin13
            if(f2_13(i).gt.0.0) then
c               write(6,10002) i,xcent13(i),f2_13(i)
            endif
         enddo
c         write(6,*) ' Q2 = 60 '
c         write(6,10001)
         do i=1,nxbin14
            if(f2_14(i).gt.0.0) then
c               write(6,10002) i,xcent14(i),f2_14(i)
            endif
         enddo
c         write(6,*) ' Q2 = 90 '
c         write(6,10001)
         do i=1,nxbin15
            if(f2_15(i).gt.0.0) then
c               write(6,10002) i,xcent15(i),f2_15(i)
            endif
         enddo
c         write(6,*) ' Q2 = 120 '
c         write(6,10001)
         do i=1,nxbin16
            if(f2_16(i).gt.0.0) then
c               write(6,10002) i,xcent16(i),f2_16(i)
            endif
         enddo
c         write(6,*) ' Q2 = 150 '
c         write(6,10001)
         do i=1,nxbin17
            if(f2_17(i).gt.0.0) then
c               write(6,10002) i,xcent17(i),f2_17(i)
            endif
         enddo

         call hpak(-1001,f2_1)
         call hpake(-1001,ef2_1)
         call hpak(-1101,f2_1)
         call hpake(-1101,eft_1)
         call hpak(-1002,f2_2)
         call hpake(-1002,ef2_2)
         call hpak(-1102,f2_2)
         call hpake(-1102,eft_2)
         call hpak(-1003,f2_3)
         call hpake(-1003,ef2_3)
         call hpak(-1103,f2_3)
         call hpake(-1103,eft_3)
         call hpak(-1004,f2_4)
         call hpake(-1004,ef2_4)
         call hpak(-1104,f2_4)
         call hpake(-1104,eft_4)
         call hpak(-1005,f2_5)
         call hpake(-1005,ef2_5)
         call hpak(-1105,f2_5)
         call hpake(-1105,eft_5)
         call hpak(-1006,f2_6)
         call hpake(-1006,ef2_6)
         call hpak(-1106,f2_6)
         call hpake(-1106,eft_6)
         call hpak(-1007,f2_7)
         call hpake(-1007,ef2_7)
         call hpak(-1107,f2_7)
         call hpake(-1107,eft_7)
         call hpak(-1008,f2_8)
         call hpake(-1008,ef2_8)
         call hpak(-1108,f2_8)
         call hpake(-1108,eft_8)
         call hpak(-1009,f2_9)
         call hpake(-1009,ef2_9)
         call hpak(-1109,f2_9)
         call hpake(-1109,eft_9)
c	   goto 123
         call hpak(-1010,f2_10)
         call hpake(-1010,ef2_10)
         call hpak(-1110,f2_10)
         call hpake(-1110,eft_10)
         call hpak(-1011,f2_11)
         call hpake(-1011,ef2_11)
         call hpak(-1111,f2_11)
         call hpake(-1111,eft_11)
         call hpak(-1012,f2_12)
         call hpake(-1012,ef2_12)
         call hpak(-1112,f2_12)
         call hpake(-1112,eft_12)
         call hpak(-1013,f2_13)
         call hpake(-1013,ef2_13)
         call hpak(-1113,f2_13)
         call hpake(-1113,eft_13)
         call hpak(-1014,f2_14)
         call hpake(-1014,ef2_14)
         call hpak(-1114,f2_14)
         call hpake(-1114,eft_14)
         call hpak(-1015,f2_15)
         call hpake(-1015,ef2_15)
         call hpak(-1115,f2_15)
         call hpake(-1115,eft_15)
         call hpak(-1016,f2_16)
         call hpake(-1016,ef2_16)
         call hpak(-1116,f2_16)
         call hpake(-1116,eft_16)
         call hpak(-1017,f2_17)
         call hpake(-1017,ef2_17)
         call hpak(-1117,f2_17)
         call hpake(-1117,eft_17)
123      continue	   
	   nall = 0
	   nall2 = 0
	   Do I=1,maxhi
	   nev(i) =0
	   enddo
*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         nall=nall+wtx
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
c            return
         endif
*
         q2=real(hzdiskin(1))
         x=real(hzdiskin(2))
         y=real(hzdiskin(3))
         w2=real(hzdiskin(4))
         iqbin = -9999
         if(q2.lt.myqbin(1).or.q2.ge.myqbin(21)) return
         i=0
   50    i=i+1
         if(q2.ge.myqbin(i).and.q2.lt.myqbin(i+1)) then
         else
            goto 50
         endif
	   iqbin = jqbin(i)
c         call  HFNT (1999)
	   if(iqbin.eq.0) return
	   q2bin(iqbin)=q2bin(iqbin)+q2
	   nq2bin(iqbin)=nq2bin(iqbin)+wtx
         call hfill(221,y,0.,wtx)
         call hfill(222,q2,0.,wtx)
* weighting with photon flux
         xw = x*q2b(iqbin)*q2b(iqbin)/(1.-y+y**2/2)
         nall2=nall2+xw
         nev(1000+iqbin)=nev(1000+iqbin)+wtx
c         write(6,*) q2,q2b(iqbin),iqbin,xw,wtx
         call hfill(1000+iqbin,x,0.,xw*wtx)
*
c	   if(x.lt.0.01.and.q2.gt.5.) then
c            if(gen(1:3).eq.'RAP') then
c               igl1=4
c               igl2=6
c            elseif(gen(1:3).eq.'PYT') then
c               igl1= 5
c               igl2= 6
c            endif
c            xkt2 = real(sqrt(phep(1,igl2)**2+phep(2,igl2)**2))
c            x2=(phep(4,igl2)+dabs(phep(3,igl2)))/2d0/phep(4,2)
c            call hfill(31,real(log10(x2)),0.,1.)
c            call hfill(32,xkt2,0.,1.)
c		write(6,*) ' hz00181 kt= ', xkt2,' xg = ',x2,' x = ',x
c	   endif
*
*
* determine kin bin of event
*                                             get electron variables
   20    continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* fill histos with f2 from pdf
* fill histos with f2 from pdf

         do i=1,17
            do j=1,nxbin
		   dx = dble(xcenter(j))
c		   goto 346
               if(i.eq.1) then
		   if(j.gt.nxbin1) goto 345
               dx = dble(xcent1(j))
		   elseif(i.eq.2) then 
		   if(j.gt.nxbin2) goto 345
               dx = dble(xcent2(j))
		   elseif(i.eq.3) then 
 		   if(j.gt.nxbin3) goto 345
               dx = dble(xcent3(j))
		   elseif(i.eq.4) then 
		   if(j.gt.nxbin4) goto 345
               dx = dble(xcent4(j))
		   elseif(i.eq.5) then 
		   if(j.gt.nxbin5) goto 345
               dx = dble(xcent5(j))
		   elseif(i.eq.6) then 
		   if(j.gt.nxbin6) goto 345
               dx = dble(xcent6(j))
		   elseif(i.eq.7) then 
		   if(j.gt.nxbin7) goto 345
               dx = dble(xcent7(j))
		   elseif(i.eq.8) then 
		   if(j.gt.nxbin8) goto 345
               dx = dble(xcent8(j))
		   elseif(i.eq.9) then 
		   if(j.gt.nxbin9) goto 345
               dx = dble(xcent9(j))
		   elseif(i.eq.10) then 
		   if(j.gt.nxbin10) goto 345
               dx = dble(xcent10(j))
		   elseif(i.eq.11) then 
		   if(j.gt.nxbin11) goto 345
               dx = dble(xcent11(j))
		   elseif(i.eq.12) then 
		   if(j.gt.nxbin12) goto 345
               dx = dble(xcent12(j))
		   elseif(i.eq.13) then 
		   if(j.gt.nxbin13) goto 345
               dx = dble(xcent13(j))
		   elseif(i.eq.14) then 
		   if(j.gt.nxbin14) goto 345
               dx = dble(xcent14(j))
		   elseif(i.eq.15) then 
		   if(j.gt.nxbin15) goto 345
               dx = dble(xcent15(j))
		   elseif(i.eq.16) then 
		   if(j.gt.nxbin16) goto 345
               dx = dble(xcent16(j))
		   elseif(i.eq.17) then 
		   if(j.gt.nxbin17) goto 345
               dx = dble(xcent17(j))
		   endif
346	         continue
               dq = dble(sqrt(q2b(i)))
               PARM(1) = 'NPTYPE'
               VAL(1) = 1.d0
               PARM(2) = 'NGROUP'
               VAL(2) = 5.d0
               VAL(2) = 4.d0
               PARM(3) = 'NSET'
               VAL(3) = 7.D0
               VAL(3) = 14.D0
               VAL(3) = 47.D0
               NPDF=NPDF+1
               PDFFIRST=.FALSE.
               IF(NPDF.LE.1) PDFFIRST=.TRUE.
c               CALL PDFSET(PARM,VAL)
c               CALL STRUCTM(dx,dq,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,
c     +         GLU)
               f2pdf=real(4./9.*(upv+usea) + 1./9.*(dnv+dsea) + 8./9.*
     +         (chm+top) + 2./9.*(str+bot) +
     +         4./9.*usea + 1./9.*dsea)
c                write(6,*) ' f2pdf ',dx,f2pdf,i
c               call hfill(2000+i,xcenter(j),0.,f2pdf)
               call hfill(2000+i,real(dx),0.,f2pdf)
345            continue
            enddo
            idhisto= 1000 +i
c            call hzchisq(-idhisto-100,2000+i)
c			   chit = chit + chi
c			   ndft = ndft + ndf
c	      write(6,*) ' hz00181 ',chi,ndf,-idhisto-100,2000+I
         enddo

        if (lp) then
*
*
* Obtain total cross-section
            write(6,*) ' Total Cross section ',xsec,nall
*
            write(6,*)'      '
         endif
*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif

*      normalize the histos
         if(nall2.gt.1) then
	      chit = 0
		ndft = 0
c	      write(6,*) ' start hz... ',chit,ndft,' xsec ',xsec,nall
c	      write(6,*) ' lum ',lum,nall2
* now do the cross section normalisation
            do i1=1,17
c		   write(6,*)' q2 bins ',i1,q2bin(i1)/nq2bin(i1),
c     &		   q2bin(i1),nq2bin(i1)
               idhisto= 1000 +i1
		   idpaw = idhisto
              call hzhinfo(idpaw,int(nev(idhisto)))
c		   write(6,*) ' enties ',nev(idhisto),idpaw
               if(nev(idhisto).gt.1) then
c		      write(6,*) ' hz00181 norm in bin i1: ',i1,q2binw(i1)
                  fact=1./(4.*pi*alph_em**2)
                  fact=fact/1000./gev2nb/lum /q2binw(i1)
                  call hzhinrm( idpaw, 0, 1., 1 )
                  call hopera(idpaw,'+E',idpaw,idpaw,fact,0.)
                  call hzchisq(-idhisto-100,idhisto)
c                  if(i1.ge.4.and.i1.ne.9) then
c                     call mychisq(-idhisto-100,idhisto,chi,ndf)
c			   chit = chit + chi
c			   ndft = ndft + ndf
c			endif
c			write(6,*) ' hz... ',chi,ndf,-idhisto-100,idhisto
               endif
            enddo
         endif
101      format('  ID ',i5,10(E8.3,1x))	   
*
*
*
      endif
      RETURN
      END
