*CMZ :          09/02/2002  17.39.35  by   H. Jung
*-- Author :  H. Jung 25-05-96
      subroutine hz01064(IFLAG)
***********************************************
* F2 data zeus-f2.9697.table.dat
*
***********************************************
      IMPLICIT NONE
*
      Real pi,dpi,rd,ee,eb,dphi,Qpi,qqradp,sigma_tot,xntot
      Logical lp
      data lp/.false./
*
      Character string*20
*
      real alph_em
      Parameter (alph_em=7.29927e-3)
      Real gev2nb,lum,fact

      Integer iqbin,i1,i3,idhisto,idpaw
      Parameter (gev2nb=0.389e6)
      Integer maxhi
      Parameter (maxhi=2000)
      Real nev(maxhi)
      Integer nentry
      Real n2,nall,nall2
      Real xw
      Data nall/0/
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real x,y,w2,q2

      double precision dx,dq
      real f2pdf
      DOUBLE PRECISION XXX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU,
     +VAL(20)
      CHARACTER*20 PARM(20)
      Integer npdf
      DATA NPDF/0/,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU/9*0.D0/
      LOGICAL PDFFIRST
      COMMON /W50516/PDFFIRST
*
*
* F2 data
*
      Integer nf5
      Parameter (nf5=5)
      Integer nf8
      Parameter (nf8=8)
      Integer nf10
      Parameter (nf10=10)
      Integer nf6
      Parameter (nf6=6)
      Integer nf9
      Parameter (nf9=9)
      Integer nxbin
	Parameter (nxbin=26)
	
      Integer nxbin1
	Parameter (nxbin1=8)
      Integer nxbin2
	Parameter (nxbin2=8)
      Integer nxbin3
	Parameter (nxbin3=8)
      Integer nxbin4
	Parameter (nxbin4=11)
      Integer nxbin5
	Parameter (nxbin5=11)
      Integer nxbin6
	Parameter (nxbin6=11)
      Integer nxbin7
	Parameter (nxbin7=11)
      Integer nxbin8
	Parameter (nxbin8=11)
      Integer nxbin9
	Parameter (nxbin9=13)
      Integer nxbin10
	Parameter (nxbin10=13)
      Integer nxbin11
	Parameter (nxbin11=13)
      Integer nxbin12
	Parameter (nxbin12=13)
      Integer nxbin13
	Parameter (nxbin13=13)
      Integer nxbin14
	Parameter (nxbin14=13)
      Integer nxbin15
	Parameter (nxbin15=13)
      Integer nxbin16
	Parameter (nxbin16=13)
      Integer nxbin17
	Parameter (nxbin17=13)
	
	
      Real f2_1(nxbin1),f2_2(nxbin2),f2_3(nxbin3)
      Real ef2_1(nxbin1),ef2_2(nxbin2),ef2_3(nxbin3)
      Real eft_1(nxbin1),eft_2(nxbin2),eft_3(nxbin3)
      Real f2_4(nxbin4),f2_5(nxbin5),f2_6(nxbin6)
      Real ef2_4(nxbin4),ef2_5(nxbin5),ef2_6(nxbin6)
      Real eft_4(nxbin4),eft_5(nxbin5),eft_6(nxbin6)
      Real f2_7(nxbin7),f2_8(nxbin8),f2_9(nxbin9)
      Real ef2_7(nxbin7),ef2_8(nxbin8),ef2_9(nxbin9)
      Real eft_7(nxbin7),eft_8(nxbin8),eft_9(nxbin9)
      Real f2_10(nxbin10),f2_11(nxbin11),f2_12(nxbin12)
      Real ef2_10(nxbin10),ef2_11(nxbin11),ef2_12(nxbin12)
      Real eft_10(nxbin10),eft_11(nxbin11),eft_12(nxbin12)
      Real f2_13(nxbin13),f2_14(nxbin14),f2_15(nxbin15)
      Real ef2_13(nxbin13),ef2_14(nxbin14),ef2_15(nxbin15)
      Real eft_13(nxbin13),eft_14(nxbin14),eft_15(nxbin15)
      Real f2_16(nxbin16),f2_17(nxbin17)
      Real ef2_16(nxbin16),ef2_17(nxbin17) 
      Real eft_16(nxbin16),eft_17(nxbin17)
	
	
      Real xx1(nf5+1),yy1(nf5),eyy1(nf5),esy1(nf5)
      Real xx2(nf8+1),yy2(nf8),eyy2(nf8),esy2(nf8)
      Real xx3(nf5+1),yy3(nf5),eyy3(nf5),esy3(nf5)
      Real xx4(nf10+1),yy4(nf10),eyy4(nf10),esy4(nf10)
      Real xx5(nf6+1),yy5(nf6),eyy5(nf6),esy5(nf6)
      Real xx6(nf9+1),yy6(nf9),eyy6(nf9),esy6(nf9)
      Real xx7(nf6+1),yy7(nf6),eyy7(nf6),esy7(nf6)
      Real xx8(nf8+1),yy8(nf8),eyy8(nf8),esy8(nf8)
      Real xx9(nf6+1),yy9(nf6),eyy9(nf6),esy9(nf6)
      Real xx10(nf9+1),yy10(nf9),eyy10(nf9),esy10(nf9)
      Real xx11(nf8+1),yy11(nf8),eyy11(nf8),esy11(nf8)
      Real xx12(nf9+1),yy12(nf9),eyy12(nf9),esy12(nf9)
      Real xx13(nf8+1),yy13(nf8),eyy13(nf8),esy13(nf8)
      Real xx14(nf9+1),yy14(nf9),eyy14(nf9),esy14(nf9)
      Real xx15(nf9+1),yy15(nf9),eyy15(nf9),esy15(nf9)
      Real xx16(nf10+1),yy16(nf10),eyy16(nf10),esy16(nf10)
      Real xx17(nf10+1),yy17(nf10),eyy17(nf10),esy17(nf10)

*
* f2 data from zeus-f2.9697.table.dat
*    f2 Q2=2.7 (bin 1)
      Data xx1/0.000063,0.000161,0.000400,0.000632,.002000,0.008/
      Data yy1/0.869136,0.744350,0.649970,0.606939,0.477483/
      Data eyy1/1.75,1.05,1.08,1.54,0.91/
      Data esy1/4.66,2.39,3.94,4.34,4.20/

*    f2 Q2=3.5 (bin 2)
      Data xx2/0.000063,0.000102,0.000161,0.000253,0.000400,
     &	0.000632,0.002000,0.008000,0.021/
      Data yy2/1.177075,0.978518,0.891477,0.832791,0.788297,
     &	0.700706,0.553627,0.471997/
      Data eyy2/2.74,2.01,1.96,1.87,1.91,1.88,0.86,1.03/
      Data esy2/12.72,3.56,2.48,2.39,2.65,2.96,2.51,6.32/
*    f2 Q2=4.5 (bin 3)
      Data xx3/0.000102,0.000161,0.000253,0.000400,
     &	0.000632,0.002/
      Data yy3/1.189312,1.013153,0.929054,0.884209,0.803575/
      Data eyy3/2.01,2.00,1.97,2.20,2.18/
      Data esy3/5.84,2.17,2.64,2.44,2.03/
*    f2 Q2=6.5 (bin 4)
      Data xx4/0.000102,0.000161,0.000253,0.000400,
     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,0.08/
      Data yy4/1.391595,1.213123,1.094461,0.977320,0.900359,0.828479,
     &	0.740112,0.666265,0.575782,0.486909/
      Data eyy4/2.37,1.52,1.49,1.53,1.58,1.57,1.77,1.24,0.94,1.15/
      Data esy4/10.23,3.62,1.88,1.75,3.08,2.11,2.54,1.86,4.14,8.68/

*    f2 Q2=8.5 (bin 5)
      Data xx5/0.000161,0.000253,0.000400,
     &	0.000632,0.001100,0.001610,0.0025/
      Data yy5/1.322712,1.222754,1.077929,0.976538,0.876609,
     &	0.813088/
      Data eyy5/2.47,1.60,1.64,1.63,1.62,1.79/
      Data esy5/9.95,2.65,1.98,2.76,1.58,1.64/

*    f2 Q2=10 (bin 6)
      Data xx6/0.000161,0.000253,0.000400,
     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,0.08/
      Data yy6/1.400457,1.290911,1.115027,1.020829,0.935424,
     &	0.851773,0.761076,0.624404,0.502634/
      Data eyy6/4.25,2.08,1.91,1.77,1.83,2.12,2.04,1.12,1.06/
      Data esy6/12.78,4.48,2.33,1.93,1.88,2.04,2.36,2.91,6.84/

*    f2 Q2=12 (bin 7)
      Data xx7/0.000253,0.000400,
     &	0.000632,0.001100,0.001610,0.002530,0.005/
      Data yy7/1.410067,1.217390,1.077680,0.985158,0.899536,
     &	0.793544/
      Data eyy7/2.61,2.30,2.05,1.96,2.22,2.11/
      Data esy7/7.47,2.72,2.28,1.93,1.60,1.90/

*    f2 Q2=15 (bin 8)
      Data xx8/0.000253,0.000400,
     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,0.08/
      Data yy8/1.559271,1.302827,1.150817,1.059345,0.945139,
     &	0.836628,0.705929,0.519319/
      Data eyy8/2.94,2.27,1.98,1.89,2.18,2.12,1.52,1.03/
      Data esy8/7.59,3.73,2.18,1.87,1.59,1.65,1.46,6.89/
     
*    f2 Q2=18 (bin 9)
      Data xx9/0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     & 	0.021/
      Data yy9/1.324623,1.169161,1.041476,0.930020,0.851166,0.739317/
      Data eyy9/1.94,2.23,2.02,2.28,2.44,1.71/
      Data esy9/4.14,2.37,2.22,1.61,1.84,1.72/

*    f2 Q2=22 (bin 10)
      Data xx10/0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.032000,0.08/
      Data yy10/1.425161,1.286816,1.071105,1.002779,0.905374,
     &	0.771006,0.656300,0.581271,0.511832/
      Data eyy10/2.55,2.20,2.26,2.72,2.55,2.37,2.43,1.95,1.82/
      Data esy10/3.95,1.93,2.28,1.96,1.74,1.69,1.74,5.60,6.90/

*    f2 Q2=27 (bin 11)
      Data xx11/0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.032/
      Data yy11/1.620285,1.325290,1.190134,1.097916,0.902310,
     &	0.803971,0.731316,0.633545/
      Data eyy11/3.32,2.45,2.27,2.82,2.74,2.55,2.63,2.03/
      Data esy11/4.01,2.17,2.66,1.72,2.14,2.48,2.66,2.88/

*    f2 Q2=35 (bin 12)
      Data xx12/0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.08/
      Data yy12/1.466542,1.241395,1.112872,0.962816,0.864672,
     &	0.727042,0.646255,0.554799,0.495781/
      Data eyy12/1.48,1.36,1.63,1.66,1.55,1.58,1.87,1.78,1.11/
      Data esy12/2.89,1.79,1.63,1.64,1.47,1.79,2.23,2.79,7.58/
	
*    f2 Q2=45 (bin 13)
      Data xx13/0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.08/
      Data yy13/1.603672,1.326997,1.139010,1.000724,0.910152,
     &	0.777432,0.660936,0.587236/
      Data eyy13/1.81,1.34,1.70,1.52,1.42,1.44,1.71,1.68/
      Data esy13/3.59,2.11,1.66,1.55,1.30,1.49,1.73,2.13/

*    f2 Q2=60 (bin 14)
      Data xx14/0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.050000,0.08/
      Data yy14/1.450091,1.229704,1.079370,0.901728,0.809394,0.688754,
     &	0.598172,0.536418,0.511578/
      Data eyy14/1.31,1.49,1.49,1.36,1.42,1.70,1.62,1.97,1.54/
      Data esy14/2.18,1.81,1.51,1.47,1.55,1.90,2.38,3.30,6.80/

*    f2 Q2=70 (bin 15)
      Data xx15/0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.050000,0.08/
      Data yy15/1.530909,1.261783,1.093596,0.986186,0.815385,0.707971,
     &	0.620393,0.556538,0.500335/
      Data eyy15/1.77,1.73,1.67,1.55,1.62,1.90,1.78,2.11,1.63/
      Data esy15/2.22,1.92,1.62,1.50,1.38,1.65,1.63,2.78,6.24/

*    f2 Q2=90 (bin 16)
      Data xx16/0.002100,0.003200,0.005000,0.008000,
     &	0.013000,0.021000,0.032000,0.050000,0.080000,0.18,0.5/
      Data yy16/1.276908,1.181574,1.032382,0.897241,0.748751,
     &	0.621373,0.534766,0.483949,0.435271,0.339495/
      Data eyy16/1.98,1.85,1.68,1.75,2.06,1.91,2.29,2.11,1.96,3.07/
      Data esy16/2.17,1.72,1.69,1.49,1.61,1.90,2.88,6.30,2.83,5.32/
	
*    f2 Q2=120 (bin 17)
      Data xx17/0.002100,0.003200,0.005000,0.008000,
     &	0.013000,0.021000,0.032000,0.050000,0.080000,0.18,0.5/
      Data yy17/1.403936,1.198474,1.045287,0.909741,0.759748,0.663825,
     &	0.578819,0.472025,0.436479,0.328099/
      Data eyy17/2.23,1.93,1.72,1.77,2.00,1.87,2.30,2.08,1.93,2.74/
      Data esy17/2.46,2.05,1.81,1.42,1.75,1.77,2.19,5.13,4.68,8.80/

      
	Real myqbin(20)
      Data myqbin/2.5,2.93,4.22,4.82,5.68,7.5,9.7,10.4,14.,16.1,
     & 20.4,23.8,30.9,40.,50.5,56.,65.,76.,108.5,200./
      Real q2b(17)
      data q2b/2.7,3.5,4.5,6.5,8.5,10.,12.,15.,18.,22.,27.,35.,45.,60.,
     &	70.,90.,120./
      Real q2binw(17)
      Real xcenter(nxbin+2),xbin(nxbin+1)
      Data xcenter/0.0000032,0.000005, 0.000008, 0.000013, 0.00002,
     +             0.000032, 0.00005,  0.00008,  0.00013,  0.0002,
     +             0.00032,  0.0005,   0.0008,   0.0013,   0.002,
     +             0.0025, 0.0032,
     +             0.004,   0.005, 0.0063,   0.008,    0.013,    0.02,
     +             0.032,    0.05,     0.08, 0.13, 0.2/
      Real xcent1(nxbin1+2),xbin1(nxbin1+1)
      Data xcent1/0.000025,
     &	0.000063,0.000102,0.000161,0.000253,0.000400,
     &	0.000632,0.002000,0.008000,
     &      0.021 /
      Real xcent2(nxbin2+2),xbin2(nxbin2+1)
c      Data xcent2/0.000025,
c     &	0.000063,0.000102,0.000161,0.000253,0.000400,
c     &	0.000632,0.002000,0.008000,
c     &      0.021 /
      Data xcent2/ 
     &	0.000063,0.000102,0.000161,0.000253,0.000400,
     &	0.000632,0.002000,0.008000,
     &      0.021, 0.032/
      Real xcent3(nxbin3+2),xbin3(nxbin3+1)
      Data xcent3/0.000025,
     &	0.000063,0.000102,0.000161,0.000253,0.000400,
     &	0.000632,0.002000,0.008000,
     &      0.021 /
      Real xcent4(nxbin4+2),xbin4(nxbin4+1)     
c      Data xcent4/0.000025,
c     &	0.000063,0.000102,0.000161,0.0002530,0.0004000,
cc     &	0.000632,0.001020,0.001610,0.002530,0.005000,0.021000,
c     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,
c     &      0.032/
      Data xcent4/
     &	0.000063,0.000102,0.000161,0.0002530,0.0004000,
     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,
     &      0.032,0.05/
c
      Real xcent5(nxbin5+2),xbin5(nxbin5+1)
      Data xcent5/0.000025,
     &	0.000063,0.000102,0.000161,0.0002530,0.0004000,
c     &	0.000632,0.001020,0.001610,0.002530,0.005000,0.021000,
     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,
     &      0.032/

      Real xcent6(nxbin6+2),xbin6(nxbin6+1)
c      Data xcent6/0.000025,
c     &	0.000063,0.000102,0.000161,0.0002530,0.0004000,
cc     &	0.000632,0.001020,0.001610,0.002530,0.005000,0.021000,
c     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,
c     &      0.032/
      Data xcent6/
     &	0.000063,0.000102,0.000161,0.0002530,0.0004000,
     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,
     &      0.032,0.05/
c
      Real xcent7(nxbin7+2),xbin7(nxbin7+1)
      Data xcent7/0.000025,
     &	0.000063,0.000102,0.000161,0.0002530,0.0004000,
c     &	0.000632,0.001020,0.001610,0.002530,0.005000,0.021000,
     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,
     &      0.032/
c
      Real xcent8(nxbin8+2),xbin8(nxbin8+1)
c      Data xcent8/0.000025,
c     &	0.000063,0.000102,0.000161,0.0002530,0.0004000,
cc     &	0.000632,0.001020,0.001610,0.002530,0.005000,0.021000,
c     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,
c     &      0.032/
      Data xcent8/
     &	0.000063,0.000102,0.000161,0.0002530,0.0004000,
c     &	0.000632,0.001020,0.001610,0.002530,0.005000,0.021000,
     &	0.000632,0.001100,0.001610,0.002530,0.005000,0.021000,
     &      0.032,0.05/
c
      Real xcent9(nxbin9+2),xbin9(nxbin9+1)
      Data xcent9/0.00025,
     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.05000,
     &      0.08000,0.18000,
     &      0.5000/
c     
      Real xcent10(nxbin10+2),xbin10(nxbin10+1)
      Data xcent10/0.00025,
     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.05000,
     &      0.08000,0.18000,
     &      0.5000/
      Real xcent11(nxbin11+2),xbin11(nxbin11+1)
      Data xcent11/0.00025,
     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.05000,
     &      0.08000,0.18000,
     &      0.5000/
      Real xcent12(nxbin12+2),xbin12(nxbin12+1)
      Data xcent12/0.00025,
     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.05000,
     &      0.08000,0.18000,
     &      0.5000/
      Real xcent13(nxbin13+2),xbin13(nxbin13+1)
      Data xcent13/0.00025,
     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.05000,
     &      0.08000,0.18000,
     &      0.5000/
      Real xcent14(nxbin14+2),xbin14(nxbin14+1)
      Data xcent14/0.00025,
     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.05000,
     &      0.08000,0.18000,
     &      0.5000/
      Real xcent15(nxbin15+2),xbin15(nxbin15+1)
c      Data xcent15/0.00025,
c     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
c     &	0.008000,0.013000,0.021000,0.032000,0.05000,
c     &      0.08000,0.18000,
c     &      0.5000/
      Data xcent15/ 
     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.05000,
     &      0.08000,0.18000,
     &      0.5000,0.9/
      Real xcent16(nxbin16+2),xbin16(nxbin16+1)
c      Data xcent16/0.00025,
c     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
c     &	0.008000,0.013000,0.021000,0.032000,0.05000,
c     &      0.08000,0.18000,
c     &      0.5000/
       Data xcent16/ 
     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.05000,
     &      0.08000,0.18000,
     &      0.5000,0.9/
      Real xcent17(nxbin17+2),xbin17(nxbin17+1)
c      Data xcent17/0.00025,
c     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
c     &	0.008000,0.013000,0.021000,0.032000,0.05000,
c     &      0.08000,0.18000,
c     &      0.5000/
      Data xcent17/ 
     &      0.000500,0.000800,0.001300,0.002100,0.003200,0.005000,
     &	0.008000,0.013000,0.021000,0.032000,0.05000,
     &      0.08000,0.18000,
     &      0.5000,0.9/
  
     

c      Real conten(nxbin),contene(nxbin)
	
	Real q2bin(17)
	Real nq2bin(17)

      Real xkt1,xkt2,x1,x2
      Integer igl1,igl2
*
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"
*
      Integer iflag,ihep,i,j,k,l,idhist
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'01064'/
*
	Double precision chi
	Integer ndf
	Double precision chit
	Integer ndft
	Common/fit/chit,ndft
	Logical First
	Data First/.true./
      real conten(nxbin)
      real sigm,wt
      common/cwnco1/x,y,Q2,sigm,wt
	integer jqbin(19)
	data jqbin/1,2,3,0,4,5,6,7,8,9,10,11,12,13,0,14,15,16,17/

      save Qpi, qqradp, first
      save xbin, xbin1, xbin2, xbin3, xbin4, xbin5, xbin6, xbin7,
     &     xbin8, xbin9, xbin10, xbin11, xbin12, xbin13, xbin14,
     &     xbin15, xbin16, xbin17
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
c         write(6,*)' hz01064 my private Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
	   first = .false.
	   Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*
         do I = 1,nxbin+1
            xbin(i) = xcenter(i) + (xcenter(i+1)-xcenter(i))/2.
         enddo

         xbin1(1)=xcent1(1)-(xcent1(2)-xcent1(1))/20.
         do I = 1,nxbin1
            xbin1(i+1) = 2*xcent1(i) - xbin1(i)
         enddo
         xbin2(1)=xcent2(1)-(xcent2(2)-xcent2(1))/20.
         do I = 1,nxbin2
            xbin2(i+1) = 2*xcent2(i) - xbin2(i)
         enddo
         xbin3(1)=xcent3(1)-(xcent3(2)-xcent3(1))/20.
         do I = 1,nxbin3
            xbin3(i+1) = 2*xcent3(i) - xbin3(i)
         enddo
         xbin4(1)=xcent4(1)-(xcent4(2)-xcent4(1))/20.
         do I = 1,nxbin4
            xbin4(i+1) = 2*xcent4(i) - xbin4(i)
         enddo
         xbin5(1)=xcent5(1)-(xcent5(2)-xcent5(1))/20.
         do I = 1,nxbin5
            xbin5(i+1) = 2*xcent5(i) - xbin5(i)
         enddo
         xbin6(1)=xcent6(1)-(xcent6(2)-xcent6(1))/20.
         do I = 1,nxbin6
            xbin6(i+1) = 2*xcent6(i) - xbin6(i)
         enddo
         xbin7(1)=xcent7(1)-(xcent7(2)-xcent7(1))/20.
         do I = 1,nxbin7
            xbin7(i+1) = 2*xcent7(i) - xbin7(i)
         enddo
         xbin8(1)=xcent8(1)-(xcent8(2)-xcent8(1))/20.
         do I = 1,nxbin8
            xbin8(i+1) = 2*xcent8(i) - xbin8(i)
         enddo
         xbin9(1)=xcent9(1)-(xcent9(2)-xcent9(1))/20.
         do I = 1,nxbin9
            xbin9(i+1) = 2*xcent9(i) - xbin9(i)
         enddo
         xbin10(1)=xcent10(1)-(xcent10(2)-xcent10(1))/20.
         do I = 1,nxbin10
            xbin10(i+1) = 2*xcent10(i) - xbin10(i)
         enddo
         xbin11(1)=xcent11(1)-(xcent11(2)-xcent11(1))/20.
         do I = 1,nxbin11
            xbin11(i+1) = 2*xcent11(i) - xbin11(i)
         enddo
         xbin12(1)=xcent12(1)-(xcent12(2)-xcent12(1))/20.
         do I = 1,nxbin12
            xbin12(i+1) = 2*xcent12(i) - xbin12(i)
         enddo
         xbin13(1)=xcent13(1)-(xcent13(2)-xcent13(1))/20.
         do I = 1,nxbin13
            xbin13(i+1) = 2*xcent13(i) - xbin13(i)
         enddo
         xbin14(1)=xcent14(1)-(xcent14(2)-xcent14(1))/20.
         do I = 1,nxbin14
            xbin14(i+1) = 2*xcent14(i) - xbin14(i)
         enddo
         xbin15(1)=xcent15(1)-(xcent15(2)-xcent15(1))/20.
         do I = 1,nxbin15
            xbin15(i+1) = 2*xcent15(i) - xbin15(i)
         enddo
         xbin16(1)=xcent16(1)-(xcent16(2)-xcent16(1))/20.
         do I = 1,nxbin16
            xbin16(i+1) = 2*xcent16(i) - xbin16(i)
         enddo
         xbin17(1)=xcent17(1)-(xcent17(2)-xcent17(1))/20.
         do I = 1,nxbin17
            xbin17(i+1) = 2*xcent17(i) - xbin17(i)
         enddo


         do i=1,19
		iqbin = jqbin(i)
		if(iqbin.ne.0) then 
		  q2binw(iqbin)=myqbin(i+1)-myqbin(i)
		endif
c		write(6,*) ' q2binw ',j,q2binw(j),myqbin(i+1),myqbin(i)
         enddo
c	   do I=1,nxbin1
c	   write(6,*) ' xbinc 1',xbin1(i),xcent1(i)
c	   enddo
c	   write(6,*) ' xbinc 1 +1,+2',xbin1(nxbin1+1),xbin1(nxbin1+2) 
c	   do I=1,nxbin2
c     	   write(6,*) ' xbinc 2',xbin2(i),xcent2(i)
c	   enddo
c	   write(6,*) ' xbinc 2 +1,+2',xbin2(nxbin2+1),xbin2(nxbin2+2) 
c	   do I=1,nxbin3
c	   write(6,*) ' xbinc 3',xbin3(i),xcent3(i)
c	   enddo
c	   write(6,*) ' xbinc 3 +1,+2',xbin3(nxbin3+1),xbin3(nxbin3+2) 
c	   do I=1,nxbin4
c	   write(6,*) ' xbinc 4',xbin4(i),xcent4(i)
c	   enddo
c	   write(6,*) ' xbinc 4 +1,+2',xbin4(nxbin4+1),xbin4(nxbin4+2) 
c	   do I=1,nxbin8
c	   write(6,*) ' xbinc 8',xbin8(i),xcent8(i)
c	   enddo
c	   write(6,*) ' xbinc 8 +1,+2',xbin8(nxbin8+1),xbin8(nxbin8+2) 
c	   do I=1,nxbin9
c	   write(6,*) ' xbinc 9',xbin9(i),xcent9(i)
c	   enddo
c	   write(6,*) ' xbinc 9 +1,+2',xbin9(nxbin9+1),xbin9(nxbin9+2) 
c	   do I=1,nxbin10
c	   write(6,*) ' xbinc 10',xbin10(i),xcent10(i)
c	   enddo
c	  write(6,*) ' xbinc 10 +1,+2',xbin10(nxbin10+1),xbin10(nxbin10+2) 
c	   do I=1,nxbin11
c	   write(6,*) ' xbinc 11',xbin11(i),xcent11(i)
c	   enddo
c	  write(6,*) ' xbinc 11 +1,+2',xbin11(nxbin11+1),xbin11(nxbin11+2) 
*****************************
*  Make histograms of F2 , F2CC and F2CC/F2 for pure PDF function
*****************************
*
c         CALL HBNT(1999,'smallx  ',' ')
c         CALL HBNAME (1999,'kin',x,'x,y,Q2,sigm,wt')

         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,100.,0.)
         call hbookb( 1001,'f2 Q2=2.7 ',nxbin1,xbin1,0.)
         call hbookb( 1002,'f2 Q2=3.5 ',nxbin2,xbin2,0.)
         call hbookb( 1003,'f2 Q2=4.5 ',nxbin3,xbin3,0.)
         call hbookb( 1004,'f2 Q2=6.5 ',nxbin4,xbin4,0.)
         call hbookb( 1005,'f2 Q2=8.5 ',nxbin5,xbin5,0.)
         call hbookb( 1006,'f2 Q2=10. ',nxbin6,xbin6,0.)
         call hbookb( 1007,'f2 Q2=12. ',nxbin7,xbin7,0.)
         call hbookb( 1008,'f2 Q2=15. ',nxbin8,xbin8,0.)
         call hbookb( 1009,'f2 Q2=18. ',nxbin9,xbin9,0.)
         call hbookb( 1010,'f2 Q2=22. ',nxbin10,xbin10,0.)
         call hbookb( 1011,'f2 Q2=27. ',nxbin11,xbin11,0.)
         call hbookb( 1012,'f2 Q2=35. ',nxbin12,xbin12,0.)
         call hbookb( 1013,'f2 Q2=45. ',nxbin13,xbin13,0.)
         call hbookb( 1014,'f2 Q2=60. ',nxbin14,xbin14,0.)
         call hbookb( 1015,'f2 Q2=70. ',nxbin15,xbin15,0.)
         call hbookb( 1016,'f2 Q2=90. ',nxbin16,xbin16,0.)
         call hbookb( 1017,'f2 Q2=120. ',nxbin17,xbin17,0.)

	   do I=1001,1017
	   call hbarx(i)
	   enddo

         call hbookb( 2001,'f2 Q2=2.7 pdf ',nxbin1,xbin1,0.)
         call hbookb( 2002,'f2 Q2=3.5 pdf ',nxbin2,xbin2,0.)
         call hbookb( 2003,'f2 Q2=4.5 pdf ',nxbin3,xbin3,0.)
         call hbookb( 2004,'f2 Q2=6.5 pdf ',nxbin4,xbin4,0.)
         call hbookb( 2005,'f2 Q2=8.5 pdf ',nxbin5,xbin5,0.)
         call hbookb( 2006,'f2 Q2=10. pdf ',nxbin6,xbin6,0.)
         call hbookb( 2007,'f2 Q2=12. pdf ',nxbin7,xbin7,0.)
         call hbookb( 2008,'f2 Q2=15. pdf ',nxbin8,xbin8,0.)
         call hbookb( 2009,'f2 Q2=18. pdf ',nxbin9,xbin9,0.)
         call hbookb( 2010,'f2 Q2=22. pdf ',nxbin10,xbin10,0.)
         call hbookb( 2011,'f2 Q2=27. pdf ',nxbin11,xbin11,0.)
         call hbookb( 2012,'f2 Q2=35. pdf ',nxbin12,xbin12,0.)
         call hbookb( 2013,'f2 Q2=45. pdf ',nxbin13,xbin13,0.)
         call hbookb( 2014,'f2 Q2=60. pdf ',nxbin14,xbin14,0.)
         call hbookb( 2015,'f2 Q2=70. pdf ',nxbin15,xbin15,0.)
         call hbookb( 2016,'f2 Q2=90. pdf ',nxbin16,xbin16,0.)
         call hbookb( 2017,'f2 Q2=120. pdf ',nxbin17,xbin17,0.)


         call hbookb( -1001,'f2 Q2=2.7 data stat',nxbin1,xbin1,0.)
         call hbookb( -1101,'f2 Q2=2.7 data tot',nxbin1,xbin1,0.)
         call hbookb( -1002,'f2 Q2=3.5 data stat',nxbin2,xbin2,0.)
         call hbookb( -1102,'f2 Q2=3.5 data tot',nxbin2,xbin2,0.)
         call hbookb( -1003,'f2 Q2=4.5 data stat',nxbin3,xbin3,0.)
         call hbookb( -1103,'f2 Q2=4.5 data tot',nxbin3,xbin3,0.)
         call hbookb( -1004,'f2 Q2=6.5 data stat',nxbin4,xbin4,0.)
         call hbookb( -1104,'f2 Q2=6.5 data tot',nxbin4,xbin4,0.)
         call hbookb( -1005,'f2 Q2=8.5 data stat',nxbin5,xbin5,0.)
         call hbookb( -1105,'f2 Q2=8.5 data tot',nxbin5,xbin5,0.)
         call hbookb( -1006,'f2 Q2=10. data stat',nxbin6,xbin6,0.)
         call hbookb( -1106,'f2 Q2=10. data tot',nxbin6,xbin6,0.)
         call hbookb( -1007,'f2 Q2=12. data stat',nxbin7,xbin7,0.)
         call hbookb( -1107,'f2 Q2=12. data tot',nxbin7,xbin7,0.)
         call hbookb( -1008,'f2 Q2=15. data stat',nxbin8,xbin8,0.)
         call hbookb( -1108,'f2 Q2=15. data tot',nxbin8,xbin8,0.)
         call hbookb( -1009,'f2 Q2=18. data stat',nxbin9,xbin9,0.)
         call hbookb( -1109,'f2 Q2=18. data tot',nxbin9,xbin9,0.)
         call hbookb( -1010,'f2 Q2=22. data stat',nxbin10,xbin10,0.)
         call hbookb( -1110,'f2 Q2=22. data tot',nxbin10,xbin10,0.)
         call hbookb( -1011,'f2 Q2=27. data stat',nxbin11,xbin11,0.)
         call hbookb( -1111,'f2 Q2=27. data tot',nxbin11,xbin11,0.)
         call hbookb( -1012,'f2 Q2=35. data stat',nxbin12,xbin12,0.)
         call hbookb( -1112,'f2 Q2=35. data tot',nxbin12,xbin12,0.)
         call hbookb( -1013,'f2 Q2=45. data stat',nxbin13,xbin13,0.)
         call hbookb( -1113,'f2 Q2=45. data tot',nxbin13,xbin13,0.)
         call hbookb( -1014,'f2 Q2=60. data stat',nxbin14,xbin14,0.)
         call hbookb( -1114,'f2 Q2=60. data tot',nxbin14,xbin14,0.)
         call hbookb( -1015,'f2 Q2=70. data stat',nxbin15,xbin15,0.)
         call hbookb( -1115,'f2 Q2=70. data tot',nxbin15,xbin15,0.)
         call hbookb( -1016,'f2 Q2=90. data stat',nxbin16,xbin16,0.)
         call hbookb( -1116,'f2 Q2=90. data tot',nxbin16,xbin16,0.)
         call hbookb( -1017,'f2 Q2=120. data stat',nxbin17,xbin17,0.)
         call hbookb( -1117,'f2 Q2=120. data tot',nxbin17,xbin17,0.)

c         call hbook1(31,' beam2 log(xg) (all)',50,-5,0.,0.)
c         call hbook1(32,' beam2 kt_2 (all)',50,0.,10.,0.)
*

         Do i =1,nxbin1
            f2_1(i)=0.
	   Enddo	
         Do i =1,nxbin2
            f2_2(i)=0.
	   Enddo	
         Do i =1,nxbin3
            f2_3(i)=0.
	   Enddo	
         Do i =1,nxbin4
            f2_4(i)=0.
	   Enddo	
         Do i =1,nxbin5
            f2_5(i)=0.
	   Enddo	
         Do i =1,nxbin6
            f2_6(i)=0.
	   Enddo	
         Do i =1,nxbin7
            f2_7(i)=0.
	   Enddo	
         Do i =1,nxbin8
            f2_8(i)=0.
	   Enddo	
         Do i =1,nxbin9
            f2_9(i)=0.
	   Enddo	
         Do i =1,nxbin10
            f2_10(i)=0.
	   Enddo	
         Do i =1,nxbin11
            f2_11(i)=0.
	   Enddo	
         Do i =1,nxbin12
            f2_12(i)=0.
	   Enddo	
         Do i =1,nxbin13
            f2_13(i)=0.
	   Enddo	
         Do i =1,nxbin14
            f2_14(i)=0.
	   Enddo	
         Do i =1,nxbin15
            f2_15(i)=0.
	   Enddo	
         Do i =1,nxbin16
            f2_16(i)=0.
	   Enddo	
         Do i =1,nxbin17
            f2_17(i)=0.
	   Enddo	
	   
         j=1
         Do i =1,nxbin1+2
            if(j.le.nf5) then
c		   write(6,*) ' xcent1 ',xcent1(i),xx1(j)
c               if(xcent1(i+1).eq.xx1(j)) then
               if(xcent1(i).eq.xx1(j)) then
                  f2_1(i)=yy1(j)
                  ef2_1(i)=yy1(j)*eyy1(j)*0.01
                  eft_1(i)=sqrt((yy1(j)*eyy1(j))**2+(yy1(j)*esy1(j))**2)
			eft_1(i)=eft_1(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin2+2
            if(j.le.nf8) then
c		   write(6,*) ' xcent2 ',xcent2(i),xx2(j),i,j
c		   write(6,*) ' xcent2 ',xcent2(i),xx2(j)
c               if(xcent2(i+1).eq.xx2(j)) then
               if(xcent2(i).eq.xx2(j)) then
                  f2_2(i)=yy2(j)
                  ef2_2(i)=yy2(j)*eyy2(j)*0.01
                  eft_2(i)=sqrt((yy2(j)*eyy2(j))**2+(yy2(j)*esy2(j))**2)
			eft_2(i)=eft_2(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin3+2
            if(j.le.nf5) then
c		   write(6,*) ' xcent3 ',xcent3(i),xx3(j)
c               if(xcent3(i+1).eq.xx3(j)) then
               if(xcent3(i).eq.xx3(j)) then
                  f2_3(i)=yy3(j)
                  ef2_3(i)=yy3(j)*eyy3(j)*0.01
                  eft_3(i)=sqrt((yy3(j)*eyy3(j))**2+(yy3(j)*esy3(j)**2))
			eft_3(i)=eft_3(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin4+2
            if(j.le.nf10) then
c		   write(6,*) ' xcent4 ',xcent4(i),xx4(j)
c               if(xcent4(i+1).eq.xx4(j)) then
               if(xcent4(i).eq.xx4(j)) then
		   write(6,*) ' xcent4 ',xcent4(i),xx4(j),j
                  f2_4(i)=yy4(j)
                  ef2_4(i)=yy4(j)*eyy4(j)*0.01
                  eft_4(i)=sqrt((yy4(j)*eyy4(j))**2+(yy4(j)*esy4(j))**2)
			eft_4(i)=eft_4(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin5+2
            if(j.le.nf6) then
c		   write(6,*) ' xcent5 ',xcent5(i),xx5(j)
c               if(xcent5(i+1).eq.xx5(j)) then
               if(xcent5(i).eq.xx5(j)) then
                  f2_5(i)=yy5(j)
                  ef2_5(i)=yy5(j)*eyy5(j)*0.01
                  eft_5(i)=sqrt((yy5(j)*eyy5(j))**2+(yy5(j)*esy5(j))**2)
			eft_5(i)=eft_5(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6+2
            if(j.le.nf9) then
c		   write(6,*) ' xcent6 ',xcent6(i),xx6(j)
c               if(xcent6(i+1).eq.xx6(j)) then
                if(xcent6(i).eq.xx6(j)) then
  		      write(6,*) ' xcent6 ',xcent6(i),xx6(j),j
                  f2_6(i)=yy6(j)
                  ef2_6(i)=yy6(j)*eyy6(j)*0.01
                  eft_6(i)=sqrt((yy6(j)*eyy6(j))**2+(yy6(j)*esy6(j))**2)
			eft_6(i)=eft_6(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin7+2
            if(j.le.nf6) then
c		   write(6,*) ' xcent7 ',xcent7(i),xx7(j)
c               if(xcent7(i+1).eq.xx7(j)) then
               if(xcent7(i).eq.xx7(j)) then
                  f2_7(i)=yy7(j)
                  ef2_7(i)=yy7(j)*eyy7(j)*0.01
                  eft_7(i)=sqrt((yy7(j)*eyy7(j))**2+(yy7(j)*esy7(j))**2)
			eft_7(i)=eft_7(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin8+2
            if(j.le.nf8) then
c		   write(6,*) ' xcent8 ',xcent8(i),xx8(j)
c               if(xcent8(i+1).eq.xx8(j)) then
               if(xcent8(i).eq.xx8(j)) then
		      write(6,*) ' xcent8 ',xcent8(i),xx8(j),j
                  f2_8(i)=yy8(j)
                  ef2_8(i)=yy8(j)*eyy8(j)*0.01
                  eft_8(i)=sqrt((yy8(j)*eyy8(j))**2+(yy8(j)*esy8(j))**2)
			eft_8(i)=eft_8(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin9+2
            if(j.le.nf6) then
c		   write(6,*) ' xcent9 ',xcent9(i),xx9(j)
c               if(xcent9(i+1).eq.xx9(j)) then
               if(xcent9(i).eq.xx9(j)) then
                  f2_9(i)=yy9(j)
                  ef2_9(i)=yy9(j)*eyy9(j)*0.01
                  eft_9(i)=sqrt((yy9(j)*eyy9(j))**2+(yy9(j)*esy9(j))**2)
			eft_9(i)=eft_9(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin10+2
            if(j.le.nf9) then
c		   write(6,*) ' xcent10 ',xcent10(i),xx10(j)
c               if(xcent10(i+1).eq.xx10(j)) then
               if(xcent10(i).eq.xx10(j)) then
                  f2_10(i)=yy10(j)
                  ef2_10(i)=yy10(j)*eyy10(j)*0.01
                  eft_10(i)=sqrt((yy10(j)*eyy10(j))**2+
     &			(yy10(j)*esy10(j))**2)
			eft_10(i)=eft_10(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin11+2
            if(j.le.nf8) then
c		   write(6,*) ' xcent11 ',xcent11(i),xx11(j)
c               if(xcent11(i+1).eq.xx11(j)) then
               if(xcent11(i).eq.xx11(j)) then
                  f2_11(i)=yy11(j)
                  ef2_11(i)=yy11(j)*eyy11(j)*0.01
                  eft_11(i) = sqrt((yy11(j)*eyy11(j))**2+
     &			(yy11(j)*esy11(j))**2)
			eft_11(i)=eft_11(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin12+2
            if(j.le.nf9) then
c		   write(6,*) ' xcent12 ',xcent12(i),xx12(j)
c               if(xcent12(i+1).eq.xx12(j)) then
               if(xcent12(i).eq.xx12(j)) then
                  f2_12(i)=yy12(j)
                  ef2_12(i)=yy12(j)*eyy12(j)*0.01
                  eft_12(i) = sqrt((yy12(j)*eyy12(j))**2+
     &			(yy12(j)*esy12(j))**2)
			eft_12(i)=eft_12(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin13+2
            if(j.le.nf8) then
c		   write(6,*) ' xcent13 ',xcent13(i),xx13(j)
c               if(xcent13(i+1).eq.xx13(j)) then
               if(xcent13(i).eq.xx13(j)) then
                  f2_13(i)=yy13(j)
                  ef2_13(i)=yy13(j)*eyy13(j)*0.01
                  eft_13(i) = sqrt((yy13(j)*eyy13(j))**2+
     &			(yy13(j)*esy13(j))**2)
			eft_13(i)=eft_13(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin14+2
            if(j.le.nf9) then
c		   write(6,*) ' xcent14 ',xcent14(i),xx14(j)
c               if(xcent14(i+1).eq.xx14(j)) then
               if(xcent14(i).eq.xx14(j)) then
                  f2_14(i)=yy14(j)
                  ef2_14(i)=yy14(j)*eyy14(j)*0.01
                  eft_14(i) = sqrt((yy14(j)*eyy14(j))**2+
     &			(yy14(j)*esy14(j))**2)
			eft_14(i)=eft_14(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin15+2
            if(j.le.nf9) then
		   write(6,*) ' xcent15 ',xcent15(i),xx15(j)
c               if(xcent15(i+1).eq.xx15(j)) then
               if(xcent15(i).eq.xx15(j)) then
                  f2_15(i)=yy15(j)
                  ef2_15(i)=yy15(j)*eyy15(j)*0.01
                  eft_15(i) = sqrt((yy15(j)*eyy15(j))**2+
     &			(yy15(j)*esy15(j))**2)
			eft_15(i)=eft_15(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin16+2
            if(j.le.nf10) then
		   write(6,*) ' xcent16 ',xcent16(i),xx16(j)
c               if(xcent16(i+1).eq.xx16(j)) then
               if(xcent16(i).eq.xx16(j)) then
                  f2_16(i)=yy16(j)
                  ef2_16(i)=yy16(j)*eyy16(j)*0.01
                  eft_16(i) = sqrt((yy16(j)*eyy16(j))**2+
     &			(yy16(j)*esy16(j))**2)
			eft_16(i)=eft_16(i)*0.01
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin17+2
            if(j.le.nf10) then
c		   write(6,*) ' xcent17 ',xcent17(i),xx17(j)
c               if(xcent17(i+1).eq.xx17(j)) then
                if(xcent17(i).eq.xx17(j)) then
                 f2_17(i)=yy17(j)
                  ef2_17(i)=yy17(j)*eyy17(j)*0.01
                  eft_17(i) = sqrt((yy17(j)*eyy17(j))**2+
     &			(yy17(j)*esy17(j))**2)
			eft_17(i)=eft_17(i)*0.01
                  j=j+1
               endif
            endif
         enddo




c         write(6,*) ' Q2 = 2.7'
c         write(6,10001)
10001  format('  bin  |     x     |   F2   | ')
         do i=1,nxbin1
            if(f2_1(i).gt.0.0) then
c               write(6,10002) i,xcent1(i),f2_1(i)
           endif
         enddo
10002  format(i6,' | ',e9.4,' | ',f6.3,' |')
c         write(6,*) ' Q2 = 3.5 '
c         write(6,10001)
         do i=1,nxbin2
            if(f2_2(i).gt.0.0) then
c               write(6,10002) i,xcent2(i),f2_2(i)
            endif
         enddo
c         write(6,*) ' Q2 = 4.5 '
c         write(6,10001)
         do i=1,nxbin3
            if(f2_3(i).gt.0.0) then
c               write(6,10002) i,xcent3(i),f2_3(i)
            endif
         enddo
         write(6,*) ' Q2 = 6.5 '
         write(6,10001)
         do i=1,nxbin4
            if(f2_4(i).gt.0.0) then
               write(6,10002) i,xcent4(i),f2_4(i)
            endif
         enddo
c         write(6,*) ' Q2 = 8.5 '
c         write(6,10001)
         do i=1,nxbin5
            if(f2_5(i).gt.0.0) then
c               write(6,10002) i,xcent5(i),f2_5(i)
            endif
         enddo
         write(6,*) ' Q2 = 10 '
         write(6,10001)
         do i=1,nxbin6
            if(f2_6(i).gt.0.0) then
               write(6,10002) i,xcent6(i),f2_6(i)
            endif
         enddo
c         write(6,*) ' Q2 = 12 '
c         write(6,10001)
         do i=1,nxbin7
            if(f2_7(i).gt.0.0) then
c               write(6,10002) i,xcent7(i),f2_7(i)
            endif
         enddo
         write(6,*) ' Q2 = 15 '
         write(6,10001)
         do i=1,nxbin8
            if(f2_8(i).gt.0.0) then
               write(6,10002) i,xcent8(i),f2_8(i)
            endif
         enddo
c         write(6,*) ' Q2 = 18 '
c         write(6,10001)
         do i=1,nxbin9
            if(f2_9(i).gt.0.0) then
c               write(6,10002) i,xcent9(i),f2_9(i)
            endif
         enddo
c         write(6,*) ' Q2 = 22 '
c         write(6,10001)
         do i=1,nxbin10
            if(f2_10(i).gt.0.0) then
c               write(6,10002) i,xcent10(i),f2_10(i)
            endif
         enddo
c         write(6,*) ' Q2 = 27 '
c         write(6,10001)
         do i=1,nxbin11
            if(f2_11(i).gt.0.0) then
c               write(6,10002) i,xcent11(i),f2_11(i)
            endif
         enddo
c         write(6,*) ' Q2 = 35 '
c         write(6,10001)
         do i=1,nxbin12
            if(f2_12(i).gt.0.0) then
c               write(6,10002) i,xcent12(i),f2_12(i)
            endif
         enddo
c         write(6,*) ' Q2 = 45 '
c         write(6,10001)
         do i=1,nxbin13
            if(f2_13(i).gt.0.0) then
c               write(6,10002) i,xcent13(i),f2_13(i)
            endif
         enddo
c         write(6,*) ' Q2 = 60 '
c         write(6,10001)
         do i=1,nxbin14
            if(f2_14(i).gt.0.0) then
c               write(6,10002) i,xcent14(i),f2_14(i)
            endif
         enddo
c         write(6,*) ' Q2 = 70 '
c         write(6,10001)
         do i=1,nxbin15
            if(f2_15(i).gt.0.0) then
c               write(6,10002) i,xcent15(i),f2_15(i)
            endif
         enddo
         write(6,*) ' Q2 = 90 '
         write(6,10001)
         do i=1,nxbin16
            if(f2_16(i).gt.0.0) then
               write(6,10002) i,xcent16(i),f2_16(i)
            endif
         enddo
         write(6,*) ' Q2 = 120 '
         write(6,10001)
         do i=1,nxbin17
            if(f2_17(i).gt.0.0) then
               write(6,10002) i,xcent17(i),f2_17(i)
            endif
         enddo

         call hpak(-1001,f2_1)
         call hpake(-1001,ef2_1)
         call hpak(-1101,f2_1)
         call hpake(-1101,eft_1)
         call hpak(-1002,f2_2)
         call hpake(-1002,ef2_2)
         call hpak(-1102,f2_2)
         call hpake(-1102,eft_2)
         call hpak(-1003,f2_3)
         call hpake(-1003,ef2_3)
         call hpak(-1103,f2_3)
         call hpake(-1103,eft_3)
         call hpak(-1004,f2_4)
         call hpake(-1004,ef2_4)
         call hpak(-1104,f2_4)
         call hpake(-1104,eft_4)
         call hpak(-1005,f2_5)
         call hpake(-1005,ef2_5)
         call hpak(-1105,f2_5)
         call hpake(-1105,eft_5)
         call hpak(-1006,f2_6)
         call hpake(-1006,ef2_6)
         call hpak(-1106,f2_6)
         call hpake(-1106,eft_6)
         call hpak(-1007,f2_7)
         call hpake(-1007,ef2_7)
         call hpak(-1107,f2_7)
         call hpake(-1107,eft_7)
         call hpak(-1008,f2_8)
         call hpake(-1008,ef2_8)
         call hpak(-1108,f2_8)
         call hpake(-1108,eft_8)
         call hpak(-1009,f2_9)
         call hpake(-1009,ef2_9)
         call hpak(-1109,f2_9)
         call hpake(-1109,eft_9)
c	   goto 123
         call hpak(-1010,f2_10)
         call hpake(-1010,ef2_10)
         call hpak(-1110,f2_10)
         call hpake(-1110,eft_10)
         call hpak(-1011,f2_11)
         call hpake(-1011,ef2_11)
         call hpak(-1111,f2_11)
         call hpake(-1111,eft_11)
         call hpak(-1012,f2_12)
         call hpake(-1012,ef2_12)
         call hpak(-1112,f2_12)
         call hpake(-1112,eft_12)
         call hpak(-1013,f2_13)
         call hpake(-1013,ef2_13)
         call hpak(-1113,f2_13)
         call hpake(-1113,eft_13)
         call hpak(-1014,f2_14)
         call hpake(-1014,ef2_14)
         call hpak(-1114,f2_14)
         call hpake(-1114,eft_14)
         call hpak(-1015,f2_15)
         call hpake(-1015,ef2_15)
         call hpak(-1115,f2_15)
         call hpake(-1115,eft_15)
         call hpak(-1016,f2_16)
         call hpake(-1016,ef2_16)
         call hpak(-1116,f2_16)
         call hpake(-1116,eft_16)
         call hpak(-1017,f2_17)
         call hpake(-1017,ef2_17)
         call hpak(-1117,f2_17)
         call hpake(-1117,eft_17)
123      continue	   
	   nall = 0
	   nall2 = 0
	   Do I=1,maxhi
	   nev(i) =0
	   enddo
*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         nall=nall+wtx
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
c            return
         endif
*
         q2=real(hzdiskin(1))
         x=real(hzdiskin(2))
         y=real(hzdiskin(3))
         w2=real(hzdiskin(4))
         iqbin = -9999
         if(q2.lt.myqbin(1).or.q2.ge.myqbin(18)) return
         i=0
   50    i=i+1
         if(q2.ge.myqbin(i).and.q2.lt.myqbin(i+1)) then
         else
            goto 50
         endif
	   iqbin = jqbin(i)
c         call  HFNT (1999)
	   if(iqbin.eq.0) then
c	     write(6,*) 'iqbin =0, q2 ',q2,' i = ',i,myqbin(i),myqbin(i+1)
	     return
	     endif
	   q2bin(iqbin)=q2bin(iqbin)+q2
	   nq2bin(iqbin)=nq2bin(iqbin)+wtx
         call hfill(221,y,0.,wtx)
         call hfill(222,q2,0.,wtx)
* weighting with photon flux
         xw = x*q2b(iqbin)*q2b(iqbin)/(1.-y+y**2/2)
         nall2=nall2+xw
         nev(1000+iqbin)=nev(1000+iqbin)+wtx
c         write(6,*) q2,q2b(iqbin),iqbin,xw,wtx
         call hfill(1000+iqbin,x,0.,xw*wtx)
c	   if(x.lt.0.01.and.q2.gt.5.) then
c            if(gen(1:3).eq.'RAP') then
c               igl1=4
c               igl2=6
c            elseif(gen(1:3).eq.'PYT') then
c               igl1= 5
c               igl2= 6
c            endif
c            xkt2 = real(sqrt(phep(1,igl2)**2+phep(2,igl2)**2))
c            x2=(phep(4,igl2)+dabs(phep(3,igl2)))/2d0/phep(4,2)
c            call hfill(31,real(log10(x2)),0.,1.)
c            call hfill(32,xkt2,0.,1.)
c		write(6,*) ' hz01064 kt= ', xkt2,' xg = ',x2,' x = ',x
c	   endif
*
*
*
* determine kin bin of event
*                                             get electron variables
   20    continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* fill histos with f2 from pdf
         do i=1,17
            do j=1,nxbin
		   dx = dble(xcenter(j))
c		   goto 346
               if(i.eq.1) then
		   if(j.gt.nxbin1) goto 345
               dx = dble(xcent1(j))
		   elseif(i.eq.2) then 
		   if(j.gt.nxbin2) goto 345
               dx = dble(xcent2(j))
		   elseif(i.eq.3) then 
 		   if(j.gt.nxbin3) goto 345
               dx = dble(xcent3(j))
		   elseif(i.eq.4) then 
		   if(j.gt.nxbin4) goto 345
               dx = dble(xcent4(j))
		   elseif(i.eq.5) then 
		   if(j.gt.nxbin5) goto 345
               dx = dble(xcent5(j))
		   elseif(i.eq.6) then 
		   if(j.gt.nxbin6) goto 345
               dx = dble(xcent6(j))
		   elseif(i.eq.7) then 
		   if(j.gt.nxbin7) goto 345
               dx = dble(xcent7(j))
		   elseif(i.eq.8) then 
		   if(j.gt.nxbin8) goto 345
               dx = dble(xcent8(j))
		   elseif(i.eq.9) then 
		   if(j.gt.nxbin9) goto 345
               dx = dble(xcent9(j))
		   elseif(i.eq.10) then 
		   if(j.gt.nxbin10) goto 345
               dx = dble(xcent10(j))
		   elseif(i.eq.11) then 
		   if(j.gt.nxbin11) goto 345
               dx = dble(xcent11(j))
		   elseif(i.eq.12) then 
		   if(j.gt.nxbin12) goto 345
               dx = dble(xcent12(j))
		   elseif(i.eq.13) then 
		   if(j.gt.nxbin13) goto 345
               dx = dble(xcent13(j))
		   elseif(i.eq.14) then 
		   if(j.gt.nxbin14) goto 345
               dx = dble(xcent14(j))
		   elseif(i.eq.15) then 
		   if(j.gt.nxbin15) goto 345
               dx = dble(xcent15(j))
		   elseif(i.eq.16) then 
		   if(j.gt.nxbin16) goto 345
               dx = dble(xcent16(j))
		   elseif(i.eq.17) then 
		   if(j.gt.nxbin17) goto 345
               dx = dble(xcent17(j))
		   endif
346	         continue
               dq = dble(sqrt(q2b(i)))
               PARM(1) = 'NPTYPE'
               VAL(1) = 1.d0
               PARM(2) = 'NGROUP'
               VAL(2) = 5.d0
               VAL(2) = 4.d0
               PARM(3) = 'NSET'
               VAL(3) = 7.D0
               VAL(3) = 14.D0
               VAL(3) = 47.D0
               NPDF=NPDF+1
               PDFFIRST=.FALSE.
               IF(NPDF.LE.1) PDFFIRST=.TRUE.
c               CALL PDFSET(PARM,VAL)
c               CALL STRUCTM(dx,dq,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,
c     +         GLU)
               f2pdf=real(4./9.*(upv+usea) + 1./9.*(dnv+dsea) + 8./9.*
     +         (chm+top) + 2./9.*(str+bot) +
     +         4./9.*usea + 1./9.*dsea)
c                write(6,*) ' f2pdf ',dx,f2pdf,i
c               call hfill(2000+i,xcenter(j),0.,f2pdf)
               call hfill(2000+i,real(dx),0.,f2pdf)
345            continue
            enddo
            idhisto= 1000 +i
c            call hzchisq(-idhisto-100,2000+i)
c			   chit = chit + chi
c			   ndft = ndft + ndf
c	      write(6,*) ' hz00181 ',chi,ndf,-idhisto-100,2000+I
         enddo

        if (lp) then
*
*
* Obtain total cross-section
            write(6,*) ' Total Cross section ',xsec,nall
*
            write(6,*)'      '
         endif
*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif

*      normalize the histos
         if(nall2.gt.1) then
	      chit = 0
		ndft = 0
c	      write(6,*) ' start hz... ',chit,ndft,' xsec ',xsec,nall
c	      write(6,*) ' lum ',lum,nall2
* now do the cross section normalisation
            do i1=1,17
c		   write(6,*)' q2 bins ',i1,q2bin(i1)/nq2bin(i1),
c     &		   q2bin(i1),nq2bin(i1)
               idhisto= 1000 +i1
		   idpaw = idhisto
              call hzhinfo(idpaw,int(nev(idhisto)))
c		   write(6,*) ' enties ',nev(idhisto),idpaw
               if(nev(idhisto).gt.1) then
c		      write(6,*) ' hz01064 norm in bin i1: ',i1,q2binw(i1)
                  fact=1./(4.*pi*alph_em**2)
                  fact=fact/1000./gev2nb/lum /q2binw(i1)
                  call hzhinrm( idpaw, 0, 1., 1 )
                  call hopera(idpaw,'+E',idpaw,idpaw,fact,0.)
                  call hzchisq(-idhisto-100,idhisto)
c                  if(i1.ge.4) then
c                     call mychisq(-idhisto-100,idhisto,chi,ndf)
c			   chit = chit + chi
c			   ndft = ndft + ndf
c			endif
c			write(6,*) ' hz... ',chi,ndf,-idhisto-100,idhisto
               endif
            enddo
         endif
101      format('  ID ',i5,10(E8.3,1x))	   
*
*
*
      endif
      RETURN
      END
