      subroutine hz99101(IFLAG)
***********************************************
* F2cc data ZEUS and D* cross sections
*
***********************************************
      IMPLICIT NONE
*
      Real pi,dpi,rd,ee,eb,dphi,Qpi,qqradp,sigma_tot,xntot
      real p,pt,et,rap,th,phang,xd,dst_xsec
      real ps,pts,ets,raps,ths,phangs
      Logical lp
      data lp/.false./
*
      Character string*20
*
      real alph_em
      Parameter (alph_em=7.29927e-3)
      Real gev2nb,lum,fact,lumnb

      Integer iqbin,i1,i3,idhisto,idpaw
      Parameter (gev2nb=0.389e6)
      Integer maxhi
      Parameter (maxhi=20000)
      Real nev(maxhi)
      Integer nentry
      Real n2,nall,nall2
      Real xw
      Data nall/0/
      data nall2/0/
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real x,y,w2,q2

      double precision dx,dq
      real f2pdf
      DOUBLE PRECISION XXX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU,
     +VAL(20)
      CHARACTER*20 PARM(20)
      Integer npdf
      DATA NPDF/0/,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU/9*0.D0/
      LOGICAL PDFFIRST
      COMMON /W50516/PDFFIRST
*
*
* F2 data
*
      Integer nf2
      Parameter (nf2=9)
      Integer nxbin
      Parameter (nxbin=15)
      Integer nxbin1
      Parameter (nxbin1=3)
      Integer nxbin2
      Parameter (nxbin2=3)
      Integer nxbin3
      Parameter (nxbin3=2)
      Integer nxbin4
      Parameter (nxbin4=3)
      Integer nxbin5
      Parameter (nxbin5=3)
      Integer nxbin6
      Parameter (nxbin6=3)
      Integer nxbin7
      Parameter (nxbin7=2)
      Integer nxbin8
      Parameter (nxbin8=2)
      Real xx1(nxbin1),yy1(nxbin1)
      Real xx2(nxbin2),yy2(nxbin2)
      Real xx3(nxbin3),yy3(nxbin3)
      Real xx4(nxbin4),yy4(nxbin4)
      Real xx5(nxbin5),yy5(nxbin5)
      Real xx6(nxbin6),yy6(nxbin6)
      Real xx7(nxbin7),yy7(nxbin7)
      Real xx8(nxbin8),yy8(nxbin8)
      Real f2_1(nxbin+2),f2_2(nxbin+2),f2_3(nxbin+2)
      Real ef2_1(nxbin+2),ef2_2(nxbin+2),ef2_3(nxbin+2)
      Real eft_1(nxbin+2),eft_2(nxbin+2),eft_3(nxbin+2)
      Real f2_4(nxbin+2),f2_5(nxbin+2),f2_6(nxbin+2)
      Real ef2_4(nxbin+2),ef2_5(nxbin+2),ef2_6(nxbin+2)
      Real eft_4(nxbin+2),eft_5(nxbin+2),eft_6(nxbin+2)
      Real f2_7(nxbin+2),f2_8(nxbin+2)
      Real ef2_7(nxbin+2),ef2_8(nxbin+2)
      Real eft_7(nxbin+2),eft_8(nxbin+2)

      Real eyy1(nxbin1),eyy2(nxbin2),eyy3(nxbin3)
      Real eyy4(nxbin4),eyy5(nxbin5),eyy6(nxbin6)
      Real eyy7(nxbin7),eyy8(nxbin8)
      Real esy1(nxbin1),esy2(nxbin2),esy3(nxbin3)
      Real esy4(nxbin4),esy5(nxbin5),esy6(nxbin6)
      Real esy7(nxbin7),esy8(nxbin8)
*
* f2cc data from ZEUS Eur. Phys. J. C 12, 35-52 (2000) DESY 99-101
*    f2 Q2=1.8 (bin 1)
      Data xx1/5.e-5, 1.3e-4,5.e-4/
      Data yy1/0.107, 0.054, 0.034/
      Data eyy1/0.017,0.011, 0.006/
      Data esy1/0.015,0.009, 0.005/

*    f2 Q2=4 (bin 2)
      Data xx2/1.3e-4, 3.0e-4, 1.2e-3/
      Data yy2/0.195,  0.088,  0.058/
      Data eyy2/0.024, 0.013,  0.009/
      Data esy2/0.018, 0.015,  0.009/

*    f2 Q2=7 (bin 3)
      Data xx3/3.0e-4, 1.2e-3/
      Data yy3/0.176, 0.095/
      Data eyy3/0.027,0.015/
      Data esy3/0.023,0.023/

*    f2 Q2=11.0 (bin 4)
      Data xx4/3.0e-4,8.0e-4,2.0e-3/
      Data yy4/0.314, 0.211, 0.123/
      Data eyy4/0.048,0.030, 0.020/
      Data esy4/0.032,0.035, 0.006/

*    f2 Q2=18 (bin 5)
      Data xx5/5.0e-4,1.2e-3,4.0e-3/
      Data yy5/0.32,  0.248, 0.136/
      Data eyy5/0.05, 0.031, 0.021/
      Data esy5/0.11, 0.028, 0.031/

*    f2 Q2=30 (bin 6)
      Data xx6/8.0e-4,2.0e-3,8.0e-3/
      Data yy6/0.395, 0.181, 0.121/
      Data eyy6/0.052,0.024, 0.021/
      Data esy6/0.050,0.025, 0.019/

*    f2 Q2=60 (bin 7)
      Data xx7/2.0e-3, 8.0e-3/
      Data yy7/0.361,  0.168/
      Data eyy7/0.077, 0.027/
      Data esy7/0.090, 0.009/
*    f2 Q2=130 (bin 8)
      Data xx8/4.0e-3, 2.0e-2/
      Data yy8/0.272,  0.109/
      Data eyy8/0.053, 0.017/
      Data esy8/0.039, 0.014/

      Real myqbin(9)
      Data myqbin/1.0,2.5,6,8.5,14.,22.,44.,90.,200./
      Real q2b(8)
      data q2b/1.8,4.0,7.0,11.0,18.0,30.0,60.0,130.0/
      Real q2binw(8)
      Real xbin(nxbin+1)
      Real xbin1(nxbin1+1),xbin2(nxbin2+1),xbin3(nxbin3+1)
      Real xbin4(nxbin4+1),xbin5(nxbin5+1),xbin6(nxbin6+1)
      Real xbin7(nxbin7+1),xbin8(nxbin8+1)
      data xbin1/4.6e-5,5.4e-5,3e-4,8e-4/
      data xbin2/1.215e-4,1.385e-4,6e-4,2.5e-3/
      data xbin3/2.55e-4,3.45e-4,4e-3/
      data xbin4/2.75e-4,3.25e-4,1.8e-3,2.4e-3/
      data xbin5/4.65e-4,5.25e-4,2.5e-3,6.5e-3/
      data xbin6/7.4e-4,8.6e-4,4.5e-3,1.4e-2/
      data xbin7/1.7e-3,2.3e-3,2.5e-2/
      data xbin8/3.2e-3,5e-3,6e-2/
      
       
      Real conten(nxbin),contene(nxbin)

      Real q2bin(8)
      Real nq2bin(8)

* Data for dsigma/dlogQ2
      Integer nlnq2
      Parameter (nlnq2=7)
      Real slnq2(nlnq2),eslnq2(nlnq2),sslnq2(nlnq2),dlnq2(nlnq2+1)
      data dlnq2/0., 0.7, 1., 1.3, 1.6, 1.9, 2.3, 2.8/
      data  slnq2/5.99, 5.17, 4.50, 2.72, 1.47, 0.47, 0.135/
      data eslnq2/0.47, 0.39, 0.33, 0.25, 0.17, 0.08, 0.073/
      data sslnq2/0.61, 0.54, 0.43, 0.32, 0.18, 0.11, 0.096/

* Data for dsigma/dlogx
      Integer nlnx
      Parameter (nlnx=5)
      Real slnx(nlnx),eslnx(nlnx),sslnx(nlnx),dlnx(nlnx+1)
      Data dlnx/ -4.1, -3.4, -2.8, -2.3, -2.0, -1.5/
      Data  slnx/4.54, 4.24, 2.06, 0.78, 0.25/
      Data eslnx/0.35, 0.23, 0.16, 0.14, 0.10/
      Data sslnx/0.45, 0.34, 0.19, 0.15, 0.11/
* Data for dsigma/dW
      Integer nW
      Parameter (nW=6)
      Real sW(nW),esW(nW),ssW(nW),dW(nW+1)
      Data dW/ 50., 90., 115., 145., 175., 200., 250./
      Data  sW/0.0450, 0.0659, 0.0510, 0.0442, 0.0361, 0.0266/
      Data esW/0.0035, 0.0048, 0.0039, 0.0038, 0.0043, 0.0032/
      Data ssW/0.0047, 0.0074, 0.0068, 0.0059, 0.0067, 0.0033/
* Data for dsigma/dxd
      Integer nxd
      Parameter (nxd=6)
      Real sxd(nxd),esxd(nxd),ssxd(nxd),dxd(nxd+1)
      Data dxd / 0.0,  0.2,  0.35,   0.5,   0.6,  0.75, 1.0/
      Data sxd / 9.3, 13.2, 13.61, 12.79,  8.15, 1.12/
      Data esxd/ 1.2,  1.2,  0.98,  1.03,  0.6,  0.10/
      Data ssxd/ 1.4,  1.9,  1.22,  1.49,  0.95, 0.27/
* Data for dsigma/dxd
      Integer npt
      Parameter (npt=5)
      Real spt(npt),espt(npt),sspt(npt),dpt(npt+1)
      Data dpt / 1.5, 2.4, 3.1, 4.0, 6.0, 15.0/
      Data spt /3.82, 2.72, 1.57, 0.527, 0.0419/
      Data espt/0.39, 0.21, 0.10, 0.033, 0.0034/
      Data sspt/0.48, 0.26, 0.14, 0.041, 0.0043/
* Data for dsigma/deta
      Integer neta
      Parameter (neta=6)
      Real seta(neta),eseta(neta),sseta(neta),deta(neta+1)
      Data deta/-1.5, -0.8, -0.35,  0.0, 0.4, 0.8, 1.5/
      Data seta/ 1.93, 2.41, 3.04, 3.09, 3.15, 3.26 /
      Data eseta/0.19, 0.21, 0.28, 0.25, 0.27, 0.31 /
      Data sseta/0.27, 0.22, 0.30, 0.30, 0.38, 0.40/

      real delta
      real sigm,phip,beta,t,x_pom,xmas,ymas
c      common/cwnco1/x,y,Q2,x_pom,beta,t,phip,xmas,ymas,sigm
*
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Double precision plab(5,NMXHEP)
      Integer iflag,ihep,i,j,k,l
      Logical charm
      Real ptdcut,rapcut,ylcut,yhcut,q2lcut,q2hcut
      Integer ndstar,idstar
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'99101'/
      real wt
      common/cwnco1/x,y,Q2

      save ndstar

*
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
c         write(6,*)' hz99101 my private Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*
         delta = 4.
         do i=1,nxbin+1
            xbin(i) = 10**(-5 + delta*(i-1)/nxbin)
c        write(6,*) ' xbin ',i,xbin(i)
         enddo
         xbin1(1)=xx1(1)-(xx1(2)-xx1(1))/20.
         
c	 do I = 1,nxbin1
c            xbin(i) = xcent(i) + (xcent(i+1)-xcent(i))/2.
c            xbin1(i+1) = 2*xx1(i) - xbin1(i)
c        write(6,*) ' xbin 1 ',i,xbin1(i),xx1(i)
c         enddo
c         xbin2(1)=xx2(1)-(xx2(2)-xx2(1))/20.
c         do I = 1,nxbin2
c            xbin2(i+1) = 2*xx2(i) - xbin2(i)
c        write(6,*) ' xbin 2 ',i,xbin2(i),xx2(i)
c         enddo
c         xbin3(1)=xx3(1)-(xx3(2)-xx3(1))/20.
c         do I = 1,nxbin3
c            xbin3(i+1) = 2*xx3(i) - xbin3(i)
c        write(6,*) ' xbin 3 ',i,xbin3(i),xx3(i)
c         enddo
c         xbin4(1)=xx4(1)-(xx4(2)-xx4(1))/20.
c         do I = 1,nxbin4
c            xbin4(i+1) = 2*xx4(i) - xbin4(i)
c        write(6,*) ' xbin 4 ',i,xbin4(i),xx4(i)
c         enddo
c         xbin5(1)=xx5(1)-(xx5(2)-xx5(1))/20.
c         do I = 1,nxbin5
c            xbin5(i+1) = 2*xx5(i) - xbin5(i)
c        write(6,*) ' xbin 5 ',i,xbin5(i),xx5(i)
c         enddo
c         xbin6(1)=xx6(1)-(xx6(2)-xx6(1))/20.
c         do I = 1,nxbin6
c            xbin6(i+1) = 2*xx6(i) - xbin6(i)
c        write(6,*) ' xbin 6 ',i,xbin6(i),xx6(i)
c         enddo
c         xbin7(1)=xx7(1)-(xx7(2)-xx7(1))/20.
c         do I = 1,nxbin7
c            xbin7(i+1) = 2*xx7(i) - xbin7(i)
c        write(6,*) ' xbin 7 ',i,xbin7(i),xx7(i)
c         enddo
c         xbin8(1)=xx8(1)-(xx8(2)-xx8(1))/20.
c         do I = 1,nxbin8
c            xbin8(i+1) = 2*xx8(i) - xbin8(i)
c        write(6,*) ' xbin 8 ',i,xbin8(i),xx8(i)
c         enddo
         do I=1,nxbin1
c        write(6,*) ' xbinc 1',xbin1(i)+(xbin1(i+1)-xbin1(i))/2.
         enddo
         do I=1,nxbin2
c        write(6,*) ' xbinc 2',xbin2(i)+(xbin2(i+1)-xbin2(i))/2.
         enddo
         do I=1,nxbin3
c        write(6,*) ' xbinc 3',xbin3(i)+(xbin3(i+1)-xbin3(i))/2.
         enddo
         do I=1,nxbin4
c        write(6,*) ' xbinc 4',xbin4(i)+(xbin4(i+1)-xbin4(i))/2.
         enddo
         do I=1,nxbin5
c        write(6,*) ' xbinc 5',xbin5(i)+(xbin5(i+1)-xbin5(i))/2.
         enddo
         do I=1,nxbin6
c        write(6,*) ' xbinc 6',xbin6(i)+(xbin6(i+1)-xbin6(i))/2.
         enddo
         do I=1,nxbin7
c        write(6,*) ' xbinc 7',xbin7(i)+(xbin7(i+1)-xbin7(i))/2.
         enddo
         do I=1,nxbin8
c        write(6,*) ' xbinc 8',xbin8(i)+(xbin8(i+1)-xbin8(i))/2.
         enddo
         do i=1,8
            j=j+1
            q2binw(j)=myqbin(i+1)-myqbin(i)
c        write(6,*) ' q2binw ',j,q2binw(j),myqbin(i+1),myqbin(i)
         enddo
*****************************
*  Make histograms of F2CC
*****************************
*
         CALL HBNT(1999,'smallx  ',' ')
         CALL HBNAME (1999,'kin',x,'x,y,Q2')
         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,100.,0.)
*
         call hbookb( 1001,'f2c Q2=1.8 ',nxbin,xbin,0.)
         call hbookb( 1002,'f2c Q2=4   ',nxbin,xbin,0.)
         call hbookb( 1003,'f2c Q2=7   ',nxbin,xbin,0.)
         call hbookb( 1004,'f2c Q2=11  ',nxbin,xbin,0.)
         call hbookb( 1005,'f2c Q2=18  ',nxbin,xbin,0.)
         call hbookb( 1006,'f2c Q2=30  ',nxbin,xbin,0.)
         call hbookb( 1007,'f2c Q2=60  ',nxbin,xbin,0.)
         call hbookb( 1008,'f2c Q2=130 ',nxbin,xbin,0.)
         call hbookb( 11001,'f2c Q2=1.8 ',nxbin1,xbin1,0.)
         call hbookb( 11002,'f2c Q2=4   ',nxbin2,xbin2,0.)
         call hbookb( 11003,'f2c Q2=7   ',nxbin3,xbin3,0.)
         call hbookb( 11004,'f2c Q2=11  ',nxbin4,xbin4,0.)
         call hbookb( 11005,'f2c Q2=18  ',nxbin5,xbin5,0.)
         call hbookb( 11006,'f2c Q2=30  ',nxbin6,xbin6,0.)
         call hbookb( 11007,'f2c Q2=60  ',nxbin7,xbin7,0.)
         call hbookb( 11008,'f2c Q2=130 ',nxbin8,xbin8,0.)
         call hbookb( -1001,'f2c Q2=1.8 data stat',nxbin1,xbin1,0.)
         call hbookb( -1101,'f2c Q2=1.8 data tot',nxbin1,xbin1,0.)
         call hbookb( -1002,'f2c Q2=4   data stat',nxbin2,xbin2,0.)
         call hbookb( -1102,'f2c Q2=4   data tot',nxbin2,xbin2,0.)
         call hbookb( -1003,'f2c Q2=7   data stat',nxbin3,xbin3,0.)
         call hbookb( -1103,'f2c Q2=7   data tot',nxbin3,xbin3,0.)
         call hbookb( -1004,'f2c Q2=11  data stat',nxbin4,xbin4,0.)
         call hbookb( -1104,'f2c Q2=11  data tot',nxbin4,xbin4,0.)
         call hbookb( -1005,'f2c Q2=18  data stat',nxbin5,xbin5,0.)
         call hbookb( -1105,'f2c Q2=18  data tot',nxbin5,xbin5,0.)
         call hbookb( -1006,'f2c Q2=30  data stat',nxbin6,xbin6,0.)
         call hbookb( -1106,'f2c Q2=30  data tot',nxbin6,xbin6,0.)
         call hbookb( -1007,'f2c Q2=60  data stat',nxbin7,xbin7,0.)
         call hbookb( -1107,'f2c Q2=60  data tot',nxbin7,xbin7,0.)
         call hbookb( -1008,'f2c Q2=130 data stat',nxbin8,xbin8,0.)
         call hbookb( -1108,'f2c Q2=130 data tot',nxbin8,xbin8,0.)

         call hbookb( 2001,' dsigma/dlogq2 ',nlnq2,dlnq2,0.)
         call hbook1( 2101,' dsigma/dlogq2 ',60,0.,3.,0.)
         call hbookb(-2001,' dsigma/dlogq2 data stat',nlnq2,dlnq2,0.)
         call hbookb(-2011,' dsigma/dlogq2 data tot ',nlnq2,dlnq2,0.)

         call hbookb( 2002,' dsigma/dlogx ',nlnx,dlnx,0.)
         call hbook1( 2102,' dsigma/dlogx ',50,-5.,0.,0.)
         call hbookb(-2002,' dsigma/dlogx data stat',nlnx,dlnx,0.)
         call hbookb(-2012,' dsigma/dlogx data tot ',nlnx,dlnx,0.)

         call hbookb( 2003,' dsigma/dW ',nW,dW,0.)
         call hbook1( 2103,' dsigma/dW ',50,50.,250.,0.)
         call hbookb(-2003,' dsigma/dW data stat',nW,dW,0.)
         call hbookb(-2013,' dsigma/dW data tot ',nW,dW,0.)

         call hbookb( 2004,' dsigma/dxD ',nxd,dxd,0.)
         call hbook1( 2104,' dsigma/dxD ',50,0.,1.,0.)
         call hbookb(-2004,' dsigma/dxD data stat',nxd,dxd,0.)
         call hbookb(-2014,' dsigma/dxD data tot ',nxd,dxd,0.)

         call hbookb( 2005,' dsigma/dpt ',npt,dpt,0.)
         call hbook1( 2105,' dsigma/dpt ',75,0.,15.,0.)
         call hbookb(-2005,' dsigma/dpt data stat',npt,dpt,0.)
         call hbookb(-2015,' dsigma/dpt data tot ',npt,dpt,0.)

         call hbookb( 2006,' dsigma/deta ',neta,deta,0.)
         call hbook1( 2106,' dsigma/deta ',60,-3.,3.,0.)
         call hbookb(-2006,' dsigma/deta data stat',neta,deta,0.)
         call hbookb(-2016,' dsigma/deta data tot ',neta,deta,0.)

         Do i =1,nxbin1
            f2_1(i)=yy1(i)
            ef2_1(i)=eyy1(i)
            eft_1(i) = sqrt(eyy1(i)**2 + esy1(i)**2)
         enddo
         Do i =1,nxbin2
            f2_2(i)=yy2(i)
            ef2_2(i)=eyy2(i)
            eft_2(i) = sqrt(eyy2(i)**2 + esy2(i)**2)
         enddo
         Do i =1,nxbin3
            f2_3(i)=yy3(i)
            ef2_3(i)=eyy3(i)
            eft_3(i) = sqrt(eyy3(i)**2 + esy3(i)**2)
         enddo
         Do i =1,nxbin4
            f2_4(i)=yy4(i)
            ef2_4(i)=eyy4(i)
            eft_4(i) = sqrt(eyy4(i)**2 + esy4(i)**2)
         enddo
         Do i =1,nxbin5
            f2_5(i)=yy5(i)
            ef2_5(i)=eyy5(i)
            eft_5(i) = sqrt(eyy5(i)**2 + esy5(i)**2)
         enddo
         Do i =1,nxbin6
            f2_6(i)=yy6(i)
            ef2_6(i)=eyy6(i)
            eft_6(i) = sqrt(eyy6(i)**2 + esy6(i)**2)
         enddo
         Do i =1,nxbin7
            f2_7(i)=yy7(i)
            ef2_7(i)=eyy7(i)
            eft_7(i) = sqrt(eyy7(i)**2 + esy7(i)**2)
         enddo
         Do i =1,nxbin8
            f2_8(i)=yy8(i)
            ef2_8(i)=eyy8(i)
            eft_8(i) = sqrt(eyy8(i)**2 + esy8(i)**2)
         enddo

         write(6,*) ' Q2 = 1.8 '
         write(6,10001)
10001  format('  bin  |     x     |   F2   | ')
         do i=1,nxbin1
            if(f2_1(i).gt.0.0) then
               write(6,10002) i,xx1(i),f2_1(i)
            endif
         enddo
10002  format(i6,' | ',e9.4,' | ',f6.3,' |')
         write(6,*) ' Q2 = 4 '
         write(6,10001)
         do i=1,nxbin2
            if(f2_2(i).gt.0.0) then
               write(6,10002) i,xx2(i),f2_2(i)
            endif
         enddo
         write(6,*) ' Q2 = 7 '
         write(6,10001)
         do i=1,nxbin3
            if(f2_3(i).gt.0.0) then
               write(6,10002) i,xx3(i),f2_3(i)
            endif
         enddo
         write(6,*) ' Q2 = 11 '
         write(6,10001)
         do i=1,nxbin4
            if(f2_4(i).gt.0.0) then
               write(6,10002) i,xx4(i),f2_4(i)
            endif
         enddo
         write(6,*) ' Q2 = 18 '
         write(6,10001)
         do i=1,nxbin5
            if(f2_5(i).gt.0.0) then
               write(6,10002) i,xx5(i),f2_5(i)
            endif
         enddo
         write(6,*) ' Q2 = 30 '
         write(6,10001)
         do i=1,nxbin6
            if(f2_6(i).gt.0.0) then
               write(6,10002) i,xx6(i),f2_6(i)
            endif
         enddo
         write(6,*) ' Q2 = 60 '
         write(6,10001)
         do i=1,nxbin7
            if(f2_7(i).gt.0.0) then
               write(6,10002) i,xx7(i),f2_7(i)
            endif
         enddo
         write(6,*) ' Q2 = 130 '
         write(6,10001)
         do i=1,nxbin8
            if(f2_8(i).gt.0.0) then
               write(6,10002) i,xx8(i),f2_8(i)
            endif
         enddo


         call hpak(-1001,f2_1)
         call hpake(-1001,ef2_1)
         call hpak(-1101,f2_1)
         call hpake(-1101,eft_1)
         call hpak(-1002,f2_2)
         call hpake(-1002,ef2_2)
         call hpak(-1102,f2_2)
         call hpake(-1102,eft_2)
         call hpak(-1003,f2_3)
         call hpake(-1003,ef2_3)
         call hpak(-1103,f2_3)
         call hpake(-1103,eft_3)
         call hpak(-1004,f2_4)
         call hpake(-1004,ef2_4)
         call hpak(-1104,f2_4)
         call hpake(-1104,eft_4)
         call hpak(-1005,f2_5)
         call hpake(-1005,ef2_5)
         call hpak(-1105,f2_5)
         call hpake(-1105,eft_5)
         call hpak(-1006,f2_6)
         call hpake(-1006,ef2_6)
         call hpak(-1106,f2_6)
         call hpake(-1106,eft_6)
         call hpak(-1007,f2_7)
         call hpake(-1007,ef2_7)
         call hpak(-1107,f2_7)
         call hpake(-1107,eft_7)
         call hpak(-1008,f2_8)
         call hpake(-1008,ef2_8)
         call hpak(-1108,f2_8)
         call hpake(-1108,eft_8)


         call hpak(-2001,slnq2)
         call hpake(-2001,eslnq2)
         call hpak(-2011,slnq2)
         call hpake(-2011,sslnq2)

         call hpak(-2002,slnx)
         call hpake(-2002,eslnx)
         call hpak(-2012,slnx)
         call hpake(-2012,sslnx)

         call hpak(-2003,sW)
         call hpake(-2003,esW)
         call hpak(-2013,sW)
         call hpake(-2013,ssW)

         call hpak(-2004,sxd)
         call hpake(-2004,esxd)
         call hpak(-2014,sxd)
         call hpake(-2014,ssxd)

         call hpak(-2005,spt)
         call hpake(-2005,espt)
         call hpak(-2015,spt)
         call hpake(-2015,sspt)

         call hpak(-2006,seta)
         call hpake(-2006,eseta)
         call hpak(-2016,seta)
         call hpake(-2016,sseta)
*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         nall=nall+wtx
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            return
         endif
*
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
         q2=real(hzdiskin(1))
         x=real(hzdiskin(2))
         y=real(hzdiskin(3))
         w2=real(hzdiskin(4))

         charm=.false.
         ptdcut = 1.5
         rapcut = 1.5
	   ylcut=0.02
	   yhcut=0.7
	   q2lcut=1.
	   q2hcut=600.
            ierr=HZIPGAM(ph)
            if (ierr.eq.-1) then
               write(6,*) 'HZ'//xxxx,' boson vector not found ! '
               call VZERO(ph,5)
            else
               Do i=1,4
                  pgam(i)=ph(i)
               enddo
            endif
*
            call HZHCMINI(pbeam,pgam,ierr)
            if (ierr.eq.1) then
               write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
               return
            endif
         Do 10 ihep=1,nhep
               Do i=1,4
                  Ph(i)=PHEP(i,ihep)
                  Plab(i,ihep)=PHEP(i,ihep)
                  phep(i,ihep)=0.0
               enddo
*
               Do i=1,4
                  Phc(i)=PLAB(i,ihep)
               enddo
            If(Iabs(idhep(ihep)).eq.4) charm=.true.
               call HZHCM(ph,pcm,ierr)
               if (ierr.eq.1) then
                  write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
                  return
               endif
               do i=1,4
                  PHEP(i,ihep)=Pcm(i)
               enddo
		
		if(y.gt.ylcut.and.y.lt.yhcut.and.
     &	q2.gt.q2lcut.and.q2.lt.q2hcut) then
* Assume JETSET gets the correct branching fraction
            if ( Iabs(idhep(ihep)) .eq. 413 ) then
c            if ( Iabs(idhep(ihep)) .eq. 4) then
               idstar=ihep
* LAB variables
               call hzgetvar(phc,p,pt,et,th,phang,rap,err_flag)
               if ( err_flag.ne.0 ) goto 10
* CMS variables
               call hzgetvar(pcm,ps,pts,ets,ths,
     +              phangs,raps,err_flag)
               if ( err_flag.ne.0 ) goto 10
               if(pt.gt.ptdcut.and.pt.le.15.and.abs(rap).le.rapcut)
     +         then
                  ndstar=ndstar+1
                  xd=2.*ps/sqrt(w2)
                  call hfill(2001,log10(q2),0.,wtx)
                  call hfill(2002,log10(x),0.,wtx)
                  call hfill(2003,sqrt(w2),0.,wtx)
                  call hfill(2004,xd,0.,wtx)
                  call hfill(2005,pt,0.,wtx)
                  call hfill(2006,rap,0.,wtx)
			
                  call hfill(2101,log10(q2),0.,wtx)
                  call hfill(2102,log10(x),0.,wtx)
                  call hfill(2103,sqrt(w2),0.,wtx)
                  call hfill(2104,xd,0.,wtx)
                  call hfill(2105,pt,0.,wtx)
                  call hfill(2106,rap,0.,wtx)
              endif
            endif
		endif
   10    Continue
* fill original PHEP vectors
            do ihep=1,nhep
               Do i=1,4
                  PHEP(i,ihep)= Plab(i,ihep)
               enddo
            enddo
         if(charm) then
            call  HFNT (1999)
            iqbin = -9999
            if(q2.lt.myqbin(1).or.q2.ge.myqbin(9)) return
            i=0
   50       i=i+1
            if(q2.ge.myqbin(i).and.q2.lt.myqbin(i+1)) then
               iqbin = i
            else
               goto 50
            endif
            q2bin(iqbin)=q2bin(iqbin)+q2
            nq2bin(iqbin)=nq2bin(iqbin)+wtx
            call hfill(221,y,0.,wtx)
            call hfill(222,q2,0.,wtx)
* weighting with photon flux
            xw = x*q2b(iqbin)*q2b(iqbin)/(1.-y+y**2/2)
            nall2=nall2+xw
            nev(1000+iqbin)=nev(1000+iqbin)+wtx
c         write(6,*) q2,q2b(iqbin),iqbin,xw,wtx
           call hfill(1000+iqbin,x,0.,xw*wtx)
            nev(11000+iqbin)=nev(11000+iqbin)+wtx
           call hfill(11000+iqbin,x,0.,xw*wtx)
         endif
*
*
*
* determine kin bin of event
*                                             get electron variables
   20    continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         if (lp) then
*
*
* Obtain total cross-section
            write(6,*) ' Total Cross section ',xsec,nall
*
            write(6,*)'      '
         endif
*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif
         dst_xsec= real(ndstar)/real(nall)*xsec*.001
	   lumnb =real(nall)/real(0.001*xsec)
         write(6,*) 'hz',xxxx,'  D* x section = ',dst_xsec
         write(6,*) 'hz',xxxx,'  nr of D*  = ',ndstar

*      normalize the histos
         if(nall2.gt.1) then
* now do the cross section normalisation
            do i1=1,8
               write(6,*)' q2 bins ',i1,q2bin(i1)/nq2bin(i1), q2bin(i1)
     +         ,nq2bin(i1)
               idhisto= 1000 +i1
               idpaw = idhisto
               call hzhinfo(idpaw,int(nev(idhisto)))
               if(nev(idhisto).gt.1) then
                  fact=1./(4.*pi*alph_em**2)
                  fact=fact/1000./gev2nb/lum /q2binw(i1)
                  call hzhinrm( idpaw, 0, 1., 1 )
                  call hopera(idpaw,'+E',idpaw,idpaw,fact,0.)
c                  write(6,*) ' hz99101 ',idhisto,nev(idhisto)

c                  call hzchisq(-idhisto-100,idhisto)
               endif
            enddo
            do i1=1,8
               write(6,*)' q2 bins ',i1,q2bin(i1)/nq2bin(i1), q2bin(i1)
     +         ,nq2bin(i1)
               idhisto= 11000 +i1
               idpaw = idhisto
               call hzhinfo(idpaw,int(nev(idhisto)))
               if(nev(idhisto).gt.1) then
                  fact=1./(4.*pi*alph_em**2)
                  fact=fact/1000./gev2nb/lum /q2binw(i1)
                  call hzhinrm( idpaw, 0, 1., 1 )
                  call hopera(idpaw,'+E',idpaw,idpaw,fact,0.)
c                  write(6,*) ' hz99101 ',idhisto,nev(idhisto)

c                  call hzchisq(-idhisto-100,idhisto)
               endif
            enddo
         endif
         call hzhinrm( 2001, 0, 1., 1 )
         call hopera(2001,'+E',2001,2001,1./lumnb,0.)
         call hzhinrm( 2002, 0, 1., 1 )
         call hopera(2002,'+E',2002,2002,1./lumnb,0.)
         call hzhinrm( 2003, 0, 1., 1 )
         call hopera(2003,'+E',2003,2003,1./lumnb,0.)
         call hzhinrm( 2004, 0, 1., 1 )
         call hopera(2004,'+E',2004,2004,1./lumnb,0.)
         call hzhinrm( 2005, 0, 1., 1 )
         call hopera(2005,'+E',2005,2005,1./lumnb,0.)
         call hzhinrm( 2006, 0, 1., 1 )
         call hopera(2006,'+E',2006,2006,1./lumnb,0.)
*
         call hzhinrm( 2101, 0, 1., 1 )
         call hopera(2101,'+E',2101,2101,1./lumnb,0.)
         call hzhinrm( 2102, 0, 1., 1 )
         call hopera(2102,'+E',2102,2102,1./lumnb,0.)
         call hzhinrm( 2103, 0, 1., 1 )
         call hopera(2103,'+E',2103,2103,1./lumnb,0.)
         call hzhinrm( 2104, 0, 1., 1 )
         call hopera(2104,'+E',2104,2104,1./lumnb,0.)
         call hzhinrm( 2105, 0, 1., 1 )
         call hopera(2105,'+E',2105,2105,1./lumnb,0.)
         call hzhinrm( 2106, 0, 1., 1 )
         call hopera(2106,'+E',2106,2106,1./lumnb,0.)
*
*
      endif
      RETURN
      END
