*
*CMZ :  1.02/07 31/03/99  11.28.15  by  Tancredi Carli
*CMZ :  1.01/01 25/03/96  15.06.06  by  Tancredi Carli
*CMZ :  0.00/03 16/01/96  18.07.27  by  Tancredi Carli
*CMZ :  0.00/01 05/01/96  14.14.00  by  HZtool
*-- Author :
      Subroutine hzhrwcop
*************************************************************
* Purpose:
* Deal with copying HERWIG HEPEVT -> HEPEVTP
* Input: none
* Output: none
* Author: N. Brook
* Modified: T. Carli: bug fix in rotation found by M. Hayes 31.3.99
*************************************************************
      PARAMETER (NMXHEP=4000)
      Double Precision phep, vhep, rmass, bfrac, cmmom, etamix, lifetm
      Double Precision phepp, vhepp
*
      COMMON/HEPEVTP/NEVHEPp,NHEPp,ISTHEPp(Nmxhep),IDHEPp(Nmxhep),
     & JMOHEPp(2,Nmxhep),JDAHEPp(2,Nmxhep),PHEPp(5,Nmxhep),
     1 VHEPp(4,Nmxhep)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
*
#include "heracmn.inc"
#include "hzfunc.inc"
*
      Double Precision pi, plab(3)
      Data pi/3.1415927/
      Logical lp
      Data lp/.false./
*
      NHEPp = NHEP
      NEVHEPp = NEVHEP
      if (lp) then
       write(6,*) ' Number of particles nhep = ',nhep
      endif
      Do ihep = 1, nhep
        isthepp(ihep) = isthep(ihep)
        idhepp(ihep) = idhep(ihep)
        jmohepp(1,ihep) = jmohep(1,ihep)
        jmohepp(2,ihep) = jmohep(2,ihep)
        jdahepp(1,ihep) = jdahep(1,ihep)
        jdahepp(2,ihep) = jdahep(2,ihep)
        do ivec = 1, 3
         plab(ivec) = phep(ivec,ihep)
        enddo
        call hzphmrot(0.d0,pi,plab,plab)
        do ivec = 1, 3
         phepp(ivec,ihep) = plab(ivec)
        Enddo
        phepp(4,ihep) = phep(4,ihep)
        phepp(5,ihep) = phep(5,ihep)
 
        if (lp) then
         write(6,*) ihep,' phep= ',(phepp(i,ihep),i=1,4)
        endif
 
        do ivec = 1, 4
         vhepp(ivec,ihep) = vhep(ivec,ihep)
        Enddo
        ihchrg(ihep) = HZLCHGE(idhep(ihep))
      Enddo
*
      Return
      End
