      SUBROUTINE HZHRWLOP(njets,jets,error)
c     -------------------------------------
c     Return the number of LO partons for HERWIG
c
c     Jon Butterworth 6/7/2000
c     ------------------------
      IMPLICIT NONE

#include "hepevtp.inc"

      INTEGER maxjet1
      PARAMETER (maxjet1=50)
      DOUBLE PRECISION jets(maxjet1,8)

      INTEGER njets, i, error
      DOUBLE PRECISION etcut, HZET, HZETA, HZPHI

      error=0
      njets=0

c     count the scatters 
      DO i=1,nhep

         IF (isthep(i).eq.123.or.isthep(i).eq.124) THEN
c     Filter out b decays
            IF (isthep(jmohep(1,i)).EQ.120) THEN
*            write(*,*) i,isthep(i),idhep(i),jmohep(1,i),hzpt(i)
               if (njets.lt.maxjet1) THEN
                  njets=njets+1
                  jets(njets,1)=hzeta(i)
                  jets(njets,2)=hzphi(i)
                  jets(njets,3)=hzet(i)
               endif
            ENDIF

         ENDIF
            
      ENDDO

      RETURN
      END
