      SUBROUTINE HZLOP(njets,jets,error)
c     ----------------------------------
c     Return a list of the LO partons from all hard scatters.
c     (Actually this routine just administrates the generator specific 
c     routines).
c
c     Jon Butterworth 6/7/2000
c     ------------------------
      IMPLICIT NONE

#include "hepevtp.inc"
#include "heracmn.inc"

      INTEGER njets, error

      INTEGER maxjet1
      PARAMETER (maxjet1=50)
      DOUBLE PRECISION jets(maxjet1,8)

      error=0

      IF (gen(1:3).EQ.'HRW') THEN

         CALL HZHRWLOP(njets,jets,error)

      ELSE IF (gen(1:3).EQ.'PYT') THEN

         CALL HZPYTLOP(njets,jets,error)

      ELSE
         WRITE(*,*) 'HZLOP: Unrecognized generator ',GEN
         error=1
         RETURN
      ENDIF

      RETURN
      END
