*CMZ :  2.00/04 31/07/2000  21.11.45  by  Tancredi Carli
*CMZ :  0.05/01 23/01/92  11.42.05  by  M. Erdmann
*-- Author :    G. Knies   24/07/91
      SUBROUTINE HEDECI (NX,NINI,IFLAG)
C----------------------------------------------------------------
C    PURPOSE:
C    INITIALIZE CONTROL COMMON FOR DECO
C
C        INPUT:  NX = no of final state vectors for the event
C        OUTPUT: COMMON QCTBUF
C
C
C   AUTHOR: G.KNIES, 24/04/91
c     modific. 26/06/91  all trax selection buisiness removed
c     modific. 19/07/91  for revised /qctbuf/
*D: QEDECI 00500 gk. add some safety
*D: QEDECI 00501 me. remove blank lines after end statement
C14/02.99 QEDECI => HEDECI for HZTOOL environment:
C14/02/99 initialize al reqired control parameters for running of DECO
C14/02/99 via CALL HEDECO, CALL HEDECX
C----------------------------------------------------------------
*
*    THE INPUT MOMENTA ARE TO BE FILLED INTO
*     COMMON/QCTBUF/..,QPI(I,IEVT) ELSEWHERE, afterwards
*    THE TOTAL NUMBER OF INPUT TRAX NX is supposed to be known
*#**********************************************************************
C****************** commons used with DECO *****************************
C                                                                      *
      integer jptmax,jfroff
      real econf
#include "qjmacs.inc"
#include "decoma.inc"

*
      Integer NP,IFLAG,NINI,I2
************************************************************************



         IFLAG=0
         IF(NINI.eq.2) goto 100
* initialize control common/QCOCOM/
         IPTMAX=JPTMAX
c... check if no more than JPTMAX particles
            IF (NX.GT.IPTMAX) GOTO 199
c         JTBI=NX
         IFUPOS= 0
c14/02/99 fill deco jets into qctbuf
         modus=1
          DO 1 I=1,10
         JETF(I)=0
         IFRAME(I)=0
         ITROFF(I)=0
         JETNAM(I)='NULL'
         INIMUL(I)=10
         IDPREV(I)=-1
    1    CONTINUE
         ECONF=30.
         MINPA=1
         ITRSRC=0
C reset input qpi(i, ievt)
         DO 12 I=1,IPTMAX+50
         DO 13 K=1,5
         QTBIR(K,I)=0.
   13    QPI(K,I)=0.
   12    CONTINUE
         DO 6 I=1,JTBOMX
         DO 5 K=1,5
    5    QPO(K,I)=0.
         DO 6 K=1,JPARMX
         QTBOR(K,I)=0.
    6    CONTINUE
* branch for h1phan
       RETURN
c hier to fill jet vector 1, as initialisation for minimization
cav  100   NP=JTBI
  100   JTBI=NX
        NP=JTBI
c        print *,'number of tracks',NX
          IF (JTBI.LT.MAXMUL) MAXMUL=JTBI
* sum up  accepted event momentum vector
               IEVT=IPTMAX+1
      DO 110 I=1,NP

      DO 101 I2=1,4
            QPI(I2,IEVT) = QPI(I2,IEVT)+QPI(I2,I)

  101 CONTINUE

            IF(QTBIR(1,I).EQ.0.)
     1      QTBIR(3,IEVT) = QTBIR(3,IEVT) + 1
  110       QTBIR(1,IEVT) = QTBIR(1,IEVT)+QTBIR(1,I)
      QPI(5,IEVT)=QPI(1,IEVT)**2 + QPI(2,IEVT)**2 + QPI(3,IEVT)**2
      QPI(5,IEVT)=SQRT(QPI(4,IEVT)**2 - QPI(5,IEVT))
         IF(NEVPRI.GE.2) THEN
         PRINT *,('EDECI,TRAX',I,(QPI(K,I),K=1,5),QTBIR(1,I),I=1,JTBI)
         PRINT *,IEVT,(QPI(JJ,IEVT),JJ=1,5),QTBIR(1,IEVT),QTBIR(3,IEVT)
         PRINT *,'EDECI, TOTAL NUMBER AND INDEX OF TRAX',
     1 JTBI, (JTBIT(I),I=1,JTBI)
         ENDIF
*
       
*****
      RETURN

 199  CONTINUE
      IFLAG=1
      PRINT *,'*** PROBLEM *** MORE THAN 150 TRAX IN EVENT:',MEVENT
     1,'EVENT IGNORED'
      RETURN
      END
