*CMZ :  0.00/05 26/01/96  13.21.02  by  Mark Hayes
*-- Author :    Mark Hayes   22/01/96
         Subroutine EUHEPC

*------- Fills arrays suitable for EUCELL jet analysis.
* from HEPEVTP HERA Workshop '95-'96
* Author : M. Hayes
*

      IMPLICIT NONE

      INTEGER Nparts,ncell1,nicell,ifbreh,j
      REAL Vmain,Uxyze
      Parameter (ncell1=500)
      COMMON/EVOKE2/ nicell,Vmain(3),Uxyze(4,ncell1),ifbreh(2,ncell1)
      REAL Eemc0,Ehac0,Etemc0,Ethac0

#include "hepevtp.inc"

      Integer*4  ibyte(4), cellvector(5)
      Character*5 cellkind
      Real*4  radius(4)/3*10000.,1./

C --- Set cell energy cuts ---------------------------------
      Eemc0  = 0.
      Ehac0  = 0.
      Etemc0 = 0.
      Ethac0 = 0.
C ---

      CALL VZERO(VMAIN,3)

	nicell=0
	Do 40 Nparts=1,NHEP

         If (nicell.ge.ncell1) THEN
           go to 900
	 ENDIF

         If (PHEP(1,Nparts)**2 + PHEP(2,Nparts)**2 .le.0.1E-12) THEN
           go to 400
	 ENDIF

	 IF (ISTHEP(Nparts).eq.1) THEN
          nicell=nicell+1

          Do 30 j=1,4
             uxyze(j,nicell) = REAL(PHEP(j,Nparts))*radius(j)
 30        CONTINUE
           ifbreh(1,nicell)= 0
           ifbreh(2,nicell)= 1
	 ENDIF

 400	CONTINUE
 40	CONTINUE
	
      return

 900  PRINT*,'EUHEPC WARNING - too many particles.  Array truncated.'
      return
      end
