         subroutine jetAlgo2
c
c     Ivan Borozan (RAL/UCL)
c
c     Jet algorithm from the Field & Stuart minimum bias study.
c
c     ---------------------------------------------------------

      IMPLICIT NONE

# include "hepevtp.inc"
# include "heracmn.inc"
      
      Integer loop200,loop9,loop10,loop201,loop65,loop68    
      Integer loop,loop2,loop3,loop1,loop4,loop5 
      Integer broj,INDEX,Ica,Jika,loop6,loop7,loop8,loop69
      REAL celija2(5,4000),celijamax,SWAPPT   
      REAL PHI,Pi,Deta,Dphi,PT,SWAP4,SWAPPHI,SWAPETA
      REAL ETA,THETA,JETPHI2(2000)
      INTEGER loop88,INDEX2,loop43,SOFT,Ica2,Jika2,TEST     
      Integer loop11,LOC,loop14,brojdva,SWAP5,TEST2 
      REAL MAXSUMPT,SUMPT2(2000),SUMPT(2000)
      REAL JETPHI(2000),MAXPHI,MINPHI,iflag  
      INTEGER countphi,loop20,loop21,loop22,Ijet
      REAL TEST3,SUMPT2MAX
      REAL SWAPSUMPT2,SWAPJETPHI2  
      REAL TWOPI,Tphi,SUMPHI4,SUMPT4 

      COMMON/newalgo/celija2,JETPHI,LOC,SUMPT,brojdva



      Pi=3.141592654
      TWOPI=2.0*Pi 
C -------------- initialise all variables and the array cell -------------    
     
         INDEX2 = 0



           
         DO Ica2=1,5
       
           DO Jika2=1,4000
       
             celija2(Ica2,Jika2) = 0.
          
             END DO

          END DO
           




          DO loop200=1,2000
           
           
           
            JETPHI(loop200) = 0.
            SUMPT(loop200) = 0.
            SUMPT2(loop200)=0.  
            JETPHI2(loop200)=0.

         END DO  
          
          TEST3=0. 
          TEST2=0          
          TEST=0 
          celijamax = 0.
          MAXSUMPT = 0.
          LOC = 0
          PT = 0.0
          THETA = 0.
          ETA = 0.
          PHI = 0.
          SWAPPT = 0.
          SWAPETA=0.
          SWAPPHI=0.
          SWAP4=0.
          SWAP5=0
          
          INDEX = 0
          Deta = 0.
          Dphi = 0. 


   
         
         iflag=0. 
         brojdva = 0
         broj = 0          
         SOFT=0


C see from where the soft events start

           DO loop43=1,NHEP
            
              IF(ISTHEP(loop43).eq.170) THEN
 
             SOFT=loop43         

             END IF

          END DO 

c          print *,'HARD'


           DO loop=1,NHEP 
          

           PT = 0.
           THETA = 0.
           ETA = 0.
           PHI = 0.



c select  only charged stable particles             

           IF((ISTHEP(loop).eq.1).and.(IHCHRG(loop).ne.0)) THEN

               IF(loop.gt.SOFT) THEN
               
                  iflag=1.0
               
                  END IF
  

C -------- Calculate PT,THETA,ETA for each particle -------
              



               
               PT=SQRT(PHEP(1,loop)**2+PHEP(2,loop)**2)
  
               THETA=ACOS(PHEP(3,loop)/SQRT(PT**2+PHEP(3,loop)
     &        **2))
              
              ETA=-ALOG(TAN(THETA/2.))

              PHI=atan2(PHEP(2,loop),PHEP(1,loop)) 
 



                   IF (PHI.LT.(0.)) then 

                     PHI = PHI + TWOPI 
    
                   END IF

                   DO WHILE(PHI.gt.TWOPI)
                     
                        PHI=PHI-TWOPI
                 
                    ENDDO                  
              

c                 print *,'********************'
c                 print *,PT     
c                 print *,ETA
c                 print *,'********************'



      IF ((PT.gt.0.5).and.(PT.lt.50.0).and.(ABS(ETA).lt.1.0)) THEN
              
              brojdva = brojdva + 1
              
              
              celija2(1,brojdva)=ETA
              celija2(2,brojdva)=PT
              celija2(3,brojdva)=PHI 
              celija2(4,brojdva)=0.0 
              celija2(5,brojdva)=iflag              
c                      print *,'********************'
c                      print *,celija2(1,brojdva)
c                      print *,celija2(2,brojdva)
c                      print *,celija2(3,brojdva)
c                      print *,celija2(4,brojdva)
c                      print *,celija2(5,brojdva)  
c                     print *,'********************'  

              END IF 

           END IF

          END DO
 




         IF(brojdva.ne.0) THEN 

            



c            IF (INDEX2.eq.1) THEN
c                             print *,brojdva        
c                                print *,'********************'               
c          
c                                  DO loop14=1,brojdva
c           
c                                print *,'ETA=',celija2(1,loop14)
c                                print *,'PT=',celija2(2,loop14)
c                                     print *,'PHI=',celija2(3,loop14)
c                                     print *,'flag=',celija2(5,loop14)  
c                                      print *,'jet=',celija2(4,loop14)
c           
c                                      END DO             
c                              
c                                 print *,'********************'               
c    
c                  END IF  
       
C -----------------------

C --------- sort particles in PT ---------------------                         



            


        IF(brojdva.gt.1) THEN        




            DO  loop1=1,brojdva-1            

                

                 celijamax=celija2(2,loop1)
                
                 
                 INDEX=loop1
                  

               DO  loop2=loop1+1,brojdva


                  IF(celija2(2,loop2).gt.celijamax) THEN
 
                        celijamax=celija2(2,loop2)                  
                  
                      INDEX=loop2
              
                  END IF
                       
               END DO 
                                    
                 SWAPPT=celija2(2,loop1)
                 SWAPETA=celija2(1,loop1)
                 SWAPPHI=celija2(3,loop1)
                 SWAP4=celija2(4,loop1)
                 SWAP5=celija2(5,loop1)                 
                 
                 celija2(2,loop1)=celija2(2,INDEX)
                 celija2(1,loop1)=celija2(1,INDEX)
                 celija2(3,loop1)=celija2(3,INDEX)
                 celija2(4,loop1)=celija2(4,INDEX)
                 celija2(5,loop1)=celija2(5,INDEX)

                  celija2(2,INDEX)=SWAPPT
                  celija2(1,INDEX)=SWAPETA
                  celija2(3,INDEX)=SWAPPHI
                  celija2(4,INDEX)=SWAP4
                  celija2(5,INDEX)=SWAP5                  

                 END DO 
             
 
                      



c             IF(INDEX2.eq.1) THEN
c
c                     DO loop201=1,brojdva        
c           
c                         print *,'PT=',celija2(2,loop201)                 
c   
c                     END DO 
c  
c             END IF  
C -------------- find jets using Field & Stuart criteria --------------

              
               Ijet=0

    
              DO loop5=1,brojdva

              Deta=0.
              Dphi=0.


c need to include this line for not overcounting            
             
             IF(celija2(4,loop5).eq.0.) THEN 
                 
         
               Ijet=Ijet+1


                DO loop4=loop5,brojdva
                
                 IF (celija2(4,loop4).eq.0.) then 

                   Deta=ABS(celija2(1,loop5)-celija2(1,loop4))
                   Dphi=ABS(celija2(3,loop5)-celija2(3,loop4))
                 
                        IF (Dphi.gt.Pi) then 
               
                            Dphi=TWOPI-Dphi            
                      
                          END IF                
                  
                    


c                  print *,'DETA',deta
c                  print *,'DPHI',dphi      
c                  RADIUS=SQRT(Deta**2+Dphi**2)
c                  print *,'RADIUS',RADIUS

                       


                      IF (SQRT(Deta**2+Dphi**2).LE.(0.7)) then
                
                          celija2(4,loop4)=Ijet
                 
                          
                        
                        END IF
                  
                    END IF

                  END DO
                 
               END IF  
              
              END DO


            
 

c                  IF (INDEX2.eq.1) THEN
c                 
c 
c                                 print *,Ijet
c                                 print *,'************************'    
c                                   DO loop8=1,brojdva
c                        
c                              print *,'PT=',celija2(2,loop8)   
c                               print *,'PHI=',celija2(3,loop8)
c                                 print *,'ETA(rap)=',celija2(1,loop8)   
c                                  print *,'jet index=',celija2(4,loop8)     
c                               print *,'cell5=',celija2(5,loop8) 
c                                      END DO  
c                                   print *,'**************************'
c                    END IF

C --sum of PT for a given jet + numb particles in a jet -------            
C --- phi of the jets     ------------------------------------- 
C - also particles must satisfay -1 < eta < 1 and PT > 0.5 GeV -- 
C ---First Calculate SUMPT and then the rest.              
                

        DO loop6=1,Ijet
                
              SUMPT4=0.               
              SUMPHI4=0.
              MAXPHI=0.
              MINPHI=TWOPI

C initialisation -------------------------

                

                 
           DO loop7=1,brojdva
 
               IF(INT(celija2(4,loop7)).eq.loop6) THEN

                  SUMPT4=SUMPT4+celija2(2,loop7)                 
                  SUMPHI4=SUMPHI4+celija2(3,loop7)*celija2(2,loop7)   
                   
               IF(celija2(3,loop7).gt.Maxphi) 
     &               Maxphi=celija2(3,loop7)                  
               IF(celija2(3,loop7).lt.Minphi)
     &               Minphi=celija2(3,loop7)  

               
                 END IF

           END DO

c                print *,'MinPhi=',minphi
c                print *,'maxphi=',maxphi


               IF((Maxphi-Minphi).gt.(3*Pi/2.)) THEN
                  
                  SUMPHI4=0.
                
                  DO loop10=1,brojdva
 
                  IF (int(celija2(4,loop10)).eq.loop6) THEN 

                   IF (celija2(3,loop10).gt.Pi) THEN
    
                     TPHI=celija2(3,loop10)-TWOPI

                    ELSE
 
                    TPHI=celija2(3,loop10) 

                   END IF

                   SUMPHI4=SUMPHI4+TPHI*celija2(2,loop10)
                  
                  END IF               
 
                  END DO 

c                   print *,'New Jetphi=',SUMPHI4
                
                 END IF

                  SUMPT(loop6)=SUMPT4  
                  JETPHI(loop6)=SUMPHI4/SUMPT4
              
                 IF(JETPHI(loop6).lt.0.) JETPHI(loop6)=
     &           JETPHI(loop6)+Twopi 
              
              

               END DO
         

c taking the highest PT jet



               DO loop3=1,Ijet
               
c                 print *,'jet number',loop3
c                 print *,'SUMPT=',SUMPT(loop3)             
c                 print *,'JETPHI=',JETPHI(loop3)        

               SUMPT2(loop3)=SUMPT(loop3) 
               JETPHI2(loop3)=JETPHI(loop3)              

               END DO
          
               MAXSUMPT=SUMPT2(1) 
 
                  DO loop10=2,Ijet
                
                        IF (SUMPT2(loop10).gt.MAXSUMPT) then
 
                       MAXSUMPT=SUMPT2(loop10)
                
                     END IF
 
                   END DO  

c                         print *,'MAXSUMPT=',MAXSUMPT
                        
               
c loc of the higest jet
                 


                   DO loop11=1,Ijet
     
                   IF(ABS(SUMPT(loop11)-MAXSUMPT)
     &            .lt.0.000001) THEN

                    LOC=loop11
                 
                    END IF
                 
                  END DO  


             END IF  

          IF (brojdva.eq.1) THEN  

               SUMPT(brojdva)=celija2(2,brojdva)       
               JETPHI(brojdva)=celija2(3,brojdva)
               LOC=brojdva
           
           END IF                     


          END IF

c             print *,'Loc of the max pt=',SUMPT(loc)
c             print *,'Jetphi of the maxpt=',JETPHI(loc)

           RETURN
        
          END 

