*CMZ :  0.00/02 14/05/97  18.59.56  by  Tancredi Carli
*CMZU:  1.00/03 10/03/96  18.28.05  by  Mark Hayes
*CMZ :  0.00/01 05/01/96  14.11.37  by  HZtool
*-- Author :
      Function Hzipgam(pgam)
*********************************************************
* Purpose:
* Hzipgam flags whether a virtual photon is found or not
* Input: none
* Output:
* If found it's 5vec (px,py,px,e,m) are passed back
* via an argument
*
* Author: N. Brook
*********************************************************
      Implicit Double Precision (A-H,O-Z)
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
*
      Dimension Pgam(5)
*
      Hzipgam = -1
CRP***Correction to find the virtual boson independent of the
CRP***used generator. Due to the agreement in the Particle Pata
CRP***Group the virtual gamma has the particle ID 23

      DO 10 ILHEP = 1,NHEP

         IF(ISTHEP(ILHEP).EQ.3) THEN


            IF(IDHEP(ILHEP).EQ.23) THEN
               HZIPGAM = 1
               IVIRT = ILHEP
               goto 11
CRP               PRINT*,'IVIRT=', IVIRT
CRP               WRITE(*,*) ' LUCK ! VIRTUAL GAMMA FOUND'
            ENDIF

            IF(IDHEP(ILHEP).EQ.22) THEN
               HZIPGAM = 1
               IVIRT  = ILHEP
               goto 11
CRP               PRINT*,'IVIRT=', IVIRT
CRP               WRITE(*,*) ' LUCK ! VIRTUAL GAMMA FOUND'
            ENDIF

         ENDIF


 10   CONTINUE
 11   continue

      IF(HZIPGAM.EQ.-1) THEN
            WRITE(*,*) 'VIRTUAL GAMMA NOT FOUND. CHECK
     &                  GENERATOR'
      ENDIF



CRP      if(gen(1:3).eq.'LEP'.or.gen(1:3).eq.'ARI') Then
CRP        ivirt = 3
CRP      else if(gen(1:3).eq.'HRW') then
CRP        ivirt = 9
CRP     to test herwig direct
CRP           ivirt = 10
CRP      else if(gen(1:3).eq.'PHO') Then
CRP        ivirt=4
CRP      else
CRP        hzipgam = -1
CRP        Write(6,*) ' HZIPGAM: UNKNOWN GENERATOR'
CRP        Return
CRP      endif
*
      pgam(1) = phep(1,ivirt)
      pgam(2) = phep(2,ivirt)
      pgam(3) = phep(3,ivirt)
      pgam(4) = phep(4,ivirt)
      pgam(5) = phep(5,ivirt)
CRP      PRINT*,'GAMMAMASS,IDHEP=', PGAM(5),IDHEP(IVIRT)


*
      Return
      End
