      SUBROUTINE HZPYTNMI(etcut,ns,error)
c     ----------------------------------
c     Give it an transverse energy cut (ETCUT) in GeV and it will
c     return the number of hard scatters in the event above the cut.
c     (PYTHIA version)
c
c     Jon Butterworth 4/3/2000
c     ------------------------
      IMPLICIT NONE

#include "hepevtp.inc"

      INTEGER ns, i, j, error
      DOUBLE PRECISION hzet, etcut

      error=0
      ns=0

c     count the "second scatters" 
      DO i=1,nhep

         IF (isthep(i).eq.2.and.jmohep(1,i).eq.0) THEN
            IF (hzet(i).GT.etcut) THEN
               ns=ns+1
            ENDIF
         ENDIF
         
      ENDDO

      ns=ns/2

      RETURN
      END
