**********************************************************   
* This Subroutine changes the D* decayed particles in Part() status 
* to 333 and the status of the D* particle to 1 (stable)

      Subroutine HzStatus (Stat, NumD, Part, CountP)
      IMPLICIT NONE

*
* HEP event prime common
* (for explanation see manual)
      Integer NMXHEP
      PARAMETER (NMXHEP=4000)
      Integer NEVHEP,NHEP,ISTHEP,IDHEP
      Integer JMOHEP,JDAHEP
      Double Precision PHEP,VHEP
      COMMON/HEPEVTP/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
*
      
      Integer Stat, I, CountP, NumD, Part(NHEP)
      
      If (Stat.eq.1) Then
* We set the D* particle as stable and the stable decay particles at a special status, to ensure
* that D* goes into a jet, and no into several jets
         ISTHEP(NumD)= 1
         Do I=1, CountP
            ISTHEP(Part(I))=  333
         End Do	      
      Else
* We set the D* particle as UNstable and the stable decay particles back to status 1 (stable), to leave
* the PHEP matrix "untouched"
         ISTHEP(NumD)= 2
         Do I=1, CountP
            ISTHEP(Part(I))=  1
         End Do	      
      End If
      
      Return
      End

