*CMZ :  1.01/15 12/08/98  20.14.07  by  Tancredi Carli
*CMZ :  1.01/11 29/12/97  11.26.36  by  Tancredi Carli
*-- Author :
      Subroutine Hzterm2
********************************************************************
*                                                                  *
* Hzterm2                                                          *
* ======                                                           *
* Author: Tancredi Carli                                           *
*                                                                  *
* Prints number of events in histogram                             *
*        total cross-section and total number of events            *
*                                                                  *
********************************************************************

      Implicit None
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Integer Maxdir
      Parameter(Maxdir=40)
      Character*8 chdir(maxdir)
      Integer Ndir, Idir, Ievt, Nevt,idn,ierr
      Real evt(2)
      Logical Hexist
      Character rout*10
      Data rout/'hzterm2 '/
*
      Call hcdir('//PAWC',' ')
*
*
      Call Hrdir(maxdir,chdir,ndir)
      If(ndir.gt.maxdir) Write(6,*) rout,' Number of directories > ',
     +  maxdir, ' only first ',maxdir, ' outputted'
*
       Do Idir = 1, min(ndir,maxdir)
         call hcdir(chdir(idir),' ')
         Write(6,*) rout,' Subdirectory: ',chdir(idir)
         Write(6,*) ' ======================'
         Write(6,*) ' '
         if(hexist(998)) Then
C           Write(6,1000)
           Call Hgnpar(998,'HZTERM')
           Call Hnoent(998,nevt)
           Do Ievt = 1, Nevt
             Call Hgnf(998,ievt,evt,ierr)
C             Write(6,*) rout,int(evt(1)),int(evt(2))
           Enddo
C           Write(6,1002)
         Endif
         Call hcdir(' \ ',' ')

       Enddo
*
      Call hcdir('//PAWC',' ')
      Call hcdir('//HISTO',' ')
      call hbook1(997,' SigmaTOT + NTOT ',2,0.,3.,0.)
      call hfill(997,1.,0.,real(xsec))
      call hfill(997,2.,0.,real(ntot))
*
      write(6,*) rout,' Total cross-section: ',real(xsec)
      write(6,*) rout,' Total number of event generated: ',ntot
*
*
       Return
*
C 1000  Format(10X,20('*')/10x,'*',10x,'*',6x,'*'/
C     1        10x,'* HISTO ID * Nbin     *,
C     +        10x,'*',10x,'*',10x,'*',6x,'*'/10X,20('*')/
C     2        10x,'*',10x,'*',6x,'*')
C 1001  Format(10X,'* ',I8,' * ',I8,' * ')
C 1002  Format(10x,'*',10x,'*',6x,'*'/10X,20('*')/' ')
       End
