*CMZ :          07/05/98  18.46.21  by  Hannes Jung
*-- Author :    H. Jung   24/03/97
      subroutine HZHACOP
*************************************************************
* Purpose:
* Deal with copying HEPEVTP -> Lund HEPEVT
* Input: none
* Output: none
* Author: H.Jung
*************************************************************
      PARAMETER (NMXHEP=4000)
      Double Precision phepp, vhepp
      COMMON/HEPEVTP/NEVHEPp,NHEPp,ISTHEPp(NMXHEP),IDHEPp(NMXHEP),
     & JMOHEPp(2,NMXHEP),JDAHEPp(2,NMXHEP),PHEPp(5,NMXHEP),
     1 VHEPp(4,NMXHEP)
*
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
*
      Logical lp
      Data lp/.false./
*
#include "heracmn.inc"
#include "hzfunc.inc"
*
      NHEP = NHEPp
      NEVHEP = NEVHEPp
      if (lp) write(6,*) ' nhep= ',nhep
      Do ihep = 1, nhep
        isthep(ihep) = isthepp(ihep)
        idhep(ihep) = idhepp(ihep)
        jmohep(1,ihep) = jmohepp(1,ihep)
        jmohep(2,ihep) = jmohepp(2,ihep)
        jdahep(1,ihep) = jdahepp(1,ihep)
        jdahep(2,ihep) = jdahepp(2,ihep)
        do ivec = 1, 5
         phep(ivec,ihep) = sngl(phepp(ivec,ihep))
        Enddo
c	   write(6,*) ' hzhacop',(phep(i,ihep),i=1,4)
        do ivec = 1, 4
         vhep(ivec,ihep) = sngl(vhepp(ivec,ihep))
        Enddo
        ihchrg(ihep) = HZLCHGE(idhep(ihep))
        if (lp) then
         write(6,*) ' ihchrg(ihep)= ',ihchrg(ihep),' id= ',idhep(ihep)
         write(6,*) ' vhep = ', (phepp(ivec,ihep),ivec=1,5)
        endif
      Enddo
c	write(6,*) ' end copy hzhacop '
*
      Return
      End
