*CMZ :  2.00/04 31/07/2000  17.46.48  by  Tancredi Carli
*CMZ :  1.01/01 25/03/96  15.06.06  by  Tancredi Carli
*CMZ :  0.00/03 16/01/96  18.07.27  by  Tancredi Carli
*CMZ :  0.00/01 05/01/96  14.14.00  by  HZtool
*-- Author :
      Subroutine hzpytcop
*************************************************************
* Purpose:
* when using herwig for partons and pythia/jetset for
* fragmentation and decays, then the 3-momentum-vectors in
* common/hepevtp/ need to be rotated.
*
* Input: none
* Output: none
* Author: G. Grindhammer
*
*************************************************************
      Integer NMXHEP
      PARAMETER (NMXHEP=4000)
      Double Precision phep, vhep, rmass, bfrac, cmmom, etamix, lifetm
      Double Precision phepp, vhepp
*
      COMMON/HEPEVTP/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),
     1 VHEP(4,NMXHEP)
*
#include "heracmn.inc"
#include "hzfunc.inc"
*
      Double Precision pi, plab(3)
      Data pi/3.1415927/
      Logical lp
      Data lp/.false./
*
      if (lp) then
       write(6,*) '**hzhrwpyt: Number of particles nhep = ',nhep
      endif
      Do ihep = 1, nhep

        if (lp) write(6,*) ihep,' 1: phep= ',(phep(i,ihep),i=1,4)

        do ivec = 1, 3
           plab(ivec) = phep(ivec,ihep)
        enddo
        call hzphmrot(0.d0,pi,plab,plab)
        do ivec = 1, 3
           phep(ivec,ihep) = plab(ivec)
        enddo

        if (lp) write(6,*) ihep,' 2: phep= ',(phep(i,ihep),i=1,4)

        ihchrg(ihep) = HZLCHGE(idhep(ihep))
      Enddo
*
      Return
      End
