*
*-- Author :
      Subroutine hzshcop
*************************************************************
* Purpose:
* Deal with copying SHERPA HEPEVT -> HEPEVTP
* Input: none
* Output: none
* Author: S. Hoeche, copied from hzhrwcop by N. Brook
*************************************************************
      PARAMETER (NMXHEP=4000)
      Double Precision phep, vhep, rmass, bfrac, cmmom, etamix, lifetm
      Double Precision phepp, vhepp
*
      COMMON/HEPEVTP/NEVHEPp,NHEPp,ISTHEPp(Nmxhep),IDHEPp(Nmxhep),
     & JMOHEPp(2,Nmxhep),JDAHEPp(2,Nmxhep),PHEPp(5,Nmxhep),
     1 VHEPp(4,Nmxhep)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
*
#include "heracmn.inc"
#include "hzfunc.inc"
*
      Double Precision pi
      Data pi/3.1415927/
      Logical lp
      Data lp/.false./
*
      NHEPp = NHEP
      NEVHEPp = NEVHEP
      if (lp) then
       write(6,*) ' Number of particles nhep = ',nhep
      endif
      Do ihep = 1, nhep
        isthepp(ihep) = isthep(ihep)
        idhepp(ihep) = idhep(ihep)
        jmohepp(1,ihep) = jmohep(1,ihep)
        jmohepp(2,ihep) = jmohep(2,ihep)
        jdahepp(1,ihep) = jdahep(1,ihep)
        jdahepp(2,ihep) = jdahep(2,ihep)
        do ivec = 1, 3
          phepp(ivec,ihep) = phep(ivec,ihep)
        Enddo
        phepp(4,ihep) = phep(4,ihep)
        phepp(5,ihep) = phep(5,ihep)
 
        if (lp) then
         write(6,*) ihep,' phep= ',(phepp(i,ihep),i=1,4)
        endif
 
        do ivec = 1, 4
         vhepp(ivec,ihep) = vhep(ivec,ihep)
        Enddo
        ihchrg(ihep) = HZLCHGE(idhep(ihep))
      Enddo
      if (lp) then
        endfile 6
      endif
*
      Return
      End
