*CMZ :  2.00/04 31/07/2000  21.11.45  by  Tancredi Carli
*CMZ :  0.03/03 05/08/91  16.48.18  by  G. Knies
*-- Author :    G. Knies   24/07/91
         SUBROUTINE HEDECO (JETFU,NAMJET,ICMS,INIMU,IPREV,IREVE)
C----------------------------------------------------------------
C   PURPOSE:
C        REQUEST FOR AN EVENT DECOMPOSITION
C        SPECIFICATION OF THE DECO MODE
*     the option of boosting the input vectors into a different LORENTZ
*     frame has been removed, for HZTOOL environment, 14/02/99
C        INPUT: COMMON/QCTBUF/ TRAX VECTORS QPI(5,I) AT 1=<I<=ITBI
C               MODE-SPECIFYING PARAMETERS AS ARGUMENTS
C        OUTPUT: COMMON /QCTBUF/ TRAX VECTORS IN REQUESTED DECO FRAME
C                COMMON/ECOCOM/
C
C   AUTHOR: G.KNIES, 24/04/91
C    adapted for HZTOOL environment, 14/02/99, G.K.
C----------------------------------------------------------------
*
*  MODIFICATIONS
*   12/06/91 charge and mass included into transformed event QPI vector
************************************************************************

*SEQ, BCS.
#include "qjmacs.inc"
#include "decoma.inc"
*
      CHARACTER*4 NAMJET
************************************************************************
C  increment call nr. ifupos = jet FUnction POSition in calling sequence
      IFUPOS=IFUPOS+1
      IF(IFUPOS.GT.10) GOTO 99
      JETF(IFUPOS)=JETFU
      JETNAM(IFUPOS)=NAMJET
      IFRAME(IFUPOS)=ICMS
      INIMUL(IFUPOS)=INIMU
      IDPREV(IFUPOS)= -1
      IF(INIMU.EQ.0) IDPREV(IFUPOS)= IPREV
      IREV(IFUPOS)=IREVE
C  allocate appropriate qpi range;
C   for DECO of event as given in qpi(,1...): itroff=0
      IF(ICMS.EQ.0)   THEN
                      ITROFF(IFUPOS)=0
                      ENDIF

  100 RETURN
   99 PRINT *,'TOO MANY JET FUNCTION CALLS, CALL IGNORED.'
      RETURN
      END
