*CMZ :          03/03/99  21.54.03  by  Hannes Jung
*CMZ :  1.01/07 14/05/98  17.23.56  by  Tancredi Carli
*-- Author :    Tancredi Carli   06/09/96
********************************************************************************
           subroutine get_var(pcm,p,pt,et,th,rap,err_flag)
           double precision   pcm(4)
           real   p,pt,et,th,rap
           integer err_flag
         real qpi,qqradP,rd

       Qpi = 4.*atan(1.)
       qqradp = 180./qpi
       rd = qqradp
           err_flag = 0
           p      = real(sqrt(pcm(1)**2+pcm(2)**2+pcm(3)**2 ))
           pt     = real(sqrt( pcm(1)**2+pcm(2)**2 ))
           if (p.eq.0.) then
c            write(6,*) ' get_var ',' p = ',p
            err_flag = -1
           else
            et     = real(pcm(4)) * pt / p
            th     = (acos(real(pcm(3))/p))
            if (abs(     th*rd).lt.1.e-4 .or.
     &          abs(180.-th*rd).lt.1.e-4 ) then
C             write(6,*) xxxx,' th = ',th
             err_flag = -2

            else
             rap    = -log(tan( th/2. ))
*                                            check on rap=nan (e.g. pt=0)
              if (rap.ne.rap) then
               write(6,*) xxxx,'Warning:  rap = ',rap,' th= ',th*rd,
     &         ' particle skipped ! '

               err_flag = -3
              endif
            endif
           endif
        return
        end
