 
 
      subroutine H1distr (id, chtitl, ncx, xlo, xhi, n, ce, ae, ye)
*****************************************************************************
*     Subroutine H1distr builds up 3 histos with H1 data:
*       Histo-ID = - id        for combined errors (ce)
*                = - (100+id)  for statist. errors (ae) only
*                = - (200+id)  for syst. errros (ye) only
*
 
      Implicit None
 
      Integer      id, ncx
      Real         xlo, xhi, n, ce, ae, ye
      Character*80 chtitl
      Dimension n(ncx)
      Dimension ce(ncx)
      Dimension ae(ncx)
      Dimension ye(ncx)
 
      call hbook1(-id, chtitl, ncx, xlo, xhi, 0.)
      call hpak(-id, n)
      call hpake(-id, ce)
 
      call hbook1(-100-id, chtitl, ncx, xlo, xhi, 0.)
      call hpak(-100-id, n)
      call hpake(-100-id, ae)
 
      call hbook1(-200-id, chtitl, ncx, xlo, xhi, 0.)
      call hpak(-200-id, n)
      call hpake(-200-id, ye)
 
      end
