      SUBROUTINE HZHRWNMI(etcut,n,error)
c     ----------------------------------
c     Give it an transverse energy cut (ETCUT) in GeV and it will
c     return the number of hard scatters in the event above the cut.
c     (HERWIG version)
c
c     Jon Butterworth 5/3/2000
c     ------------------------
      IMPLICIT NONE

#include "hepevtp.inc"

      INTEGER n, i, error, nparton
      DOUBLE PRECISION etcut, HZET

      error=0
      n=0
      nparton=0

c     count the scatters 
      DO i=1,nhep

         IF (isthep(i).eq.123.or.isthep(i).eq.124) THEN
*            write(*,*) i,isthep(i),idhep(i),jmohep(1,i),hzpt(i)
            IF (hzet(i).GT.etcut) THEN
               nparton=nparton+1
            ENDIF
         ENDIF
            
      ENDDO

      IF (MOD(nparton,2).EQ.1) THEN
         nparton=nparton+1
      ENDIF

      n=nparton/2

      RETURN
      END
