
      SUBROUTINE hzkhisdef(n1,n2,chnazev,ioffset,nxbins,xbins)
c
c       Create sets of histograms
c       Input:  n1 * n2 ... number of histograms
c               chnazev ... name of the histogram
c               ioffset ... offset (last 2 digits in histogram numbering)
c               xbins(nxbins+1) ... array of histogram binning
c
      implicit none
      
      integer   n1,n2,ioffset,nxbins,nxbinsmax
      parameter(nxbinsmax=100)
      real      xbins(nxbinsmax)
      character*80 chnazev

      integer   i,j,k,const,id
      parameter(const=40000)

      k=0
      do i=1,n1
        do j=1,n2
          k=k+1
          id=const+k*100+ioffset
          call HBOOKB(id,chnazev,nxbins,xbins,0.)
          call HBARX(id)
        enddo
      enddo
      return
      END
