*CMZ :  1.02/02 23/10/98  11.02.43  by  Tancredi Carli
*-- Author :
      FUNCTION HzP (ipart)
************************************************************************
*     input:  ipart:        index of particle in HEP common
*     output: return value: momentum of particle
*     no other subroutines are called
*     written by: Oliver Gutsche
************************************************************************
 
      IMPLICIT NONE
 
*KEEP,HEPEVTP.
*
* HEP event prime common
* (for explanation see manual)
      Integer NMXHEP
      PARAMETER (NMXHEP=4000)
      Integer NEVHEP,NHEP,ISTHEP,IDHEP
      Integer JMOHEP,JDAHEP
      Double Precision PHEP,VHEP
      COMMON/HEPEVTP/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
*
*KEND.
 
      Double Precision HzP
      Integer ipart
      Double Precision dpx, dpy, dpz, dp
 
c --- check particle index
      if ((ipart.lt.1).or.(ipart.gt.NHEP)) then
         dp = 0.D0
      else
 
c --- get particle pt
         dpx = PHEP(1,ipart)
         dpy = PHEP(2,ipart)
         dpz = PHEP(3,ipart)
         dp  = SQRT(dpx**2+dpy**2+dpz**2)
 
      endif
 
      HzP = dp
 
      RETURN
      END






